<?php
if ( ! defined( 'ABSPATH' ) ) exit;

include('titan-framework/titan-framework-embedder.php');

function divi_machine_options() {
$titan = TitanFramework::getInstance( 'divi-machine' );

$get_divi_engine_menu = get_option('divi-engine-menu', null);
if ($get_divi_engine_menu == "" || $get_divi_engine_menu == "machine-added") {
  update_option('divi-engine-menu', 'machine-added');
$titan = TitanFramework::getInstance( 'divi-machine' );
$icon = plugins_url( 'images/dash-icon.svg', __FILE__ );
$admin_panel2 = $titan->createAdminPanel( array( 'name' => 'Divi Engine', 'capability' => 'edit_pages' , 'icon' => $icon . '' , 'id' => 'divi-engine',) );
$welcometab = $admin_panel2->createTab( array('name' => 'Welcome',) );
$welcometab->createOption( array(
'name' => ''.esc_html__( "Welcome to Divi Engine!", 'divi-machine' ).'',
'type' => 'heading',
) );
$welcometab->createOption( array(
'type' => 'note',
'desc' => ''.esc_html__( "Firstly we would like to thank you for purchasing one of our plugins! We hope that you find it useful in your web design adventures.", 'divi-machine' ).''
) );

$welcometab->createOption( array(
'name' => ''.esc_html__( "Tech Support", 'divi-machine' ).'',
'type' => 'heading',
) );
$welcometab->createOption( array(
'type' => 'note',
'desc' => ''.esc_html__( 'We know from time to time, things may not go to plan due to the number of different setups on WordPress sites.', 'divi-machine' ).'<br>'.esc_html__( 'Dont worry, we are here to help. First take a look at our documentation (see below), if you cannot find a solution, use our support section on our site and we will help you resolve any issues.', 'divi-machine' ).'<br>
<a href="https://diviengine.com/support/" target="_blank"><img style="position: relative;left: 0;top: 12px;width: 200px;transform: translateY(0);" src="'.DE_DMACH_PATH_URL . '/images/admin-area/support-ticket.png"></a>
  ',
) );

$welcometab->createOption( array(
'name' => ''.esc_html__( "Documentation", 'divi-machine' ).'',
'type' => 'heading',
) );
$welcometab->createOption( array(
'type' => 'note',
'desc' => '<h4>'.esc_html__( "We have created documentation for all our plugins - you can read up on them using the links below.", 'divi-machine' ).'</h4>
<a style="text-decoration: none;font-size: 17px;color: #1e136e;font-weight: 500;" href="https://help.diviengine.com/category/36-divi-nitro/" target="_blank"><img style="position:relative;left:0;top:0;transform: translateY(0);width: 50px;" src="'.DE_DMACH_PATH_URL . '/images/admin-area/divi-nitro-plugin-featured-150x150.png"><span style="position: relative;top: -13px;left: 10px;">'.esc_html__( "Divi Nitro", 'divi-machine' ).'</span></a><br>
<a style="text-decoration: none;font-size: 17px;color: #1e136e;font-weight: 500;" href="https://help.diviengine.com/category/9-divi-bodycommerce" target="_blank"><img style="position:relative;left:0;top:0;transform: translateY(0);width: 50px;" src="'.DE_DMACH_PATH_URL . '/images/admin-area/divi-bodycommerce-plugin-featured-150x150.png"><span style="position: relative;top: -13px;left: 10px;">'.esc_html__( "Divi BodyCommerce", 'divi-machine' ).'</span></a><br>
<a style="text-decoration: none;font-size: 17px;color: #1e136e;font-weight: 500;" href="https://help.diviengine.com/category/43-divi-protect/" target="_blank"><img style="position:relative;left:0;top:0;transform: translateY(0);width: 50px;" src="'.DE_DMACH_PATH_URL . '/images/admin-area/divi-protect-plugin-featured-150x150.png"><span style="position: relative;top: -13px;left: 10px;">'.esc_html__( "Divi Protect", 'divi-machine' ).'</span></a><br>
<a style="text-decoration: none;font-size: 17px;color: #1e136e;font-weight: 500;" href="https://help.diviengine.com/category/45-divi-mega-menu/" target="_blank"><img style="position:relative;left:0;top:0;transform: translateY(0);width: 50px;" src="'.DE_DMACH_PATH_URL . '/images/admin-area/divi-mega-menu-plugin-featured-150x150.png"><span style="position: relative;top: -13px;left: 10px;">'.esc_html__( "Divi Mega Menu", 'divi-machine' ).'</span></a><br>
<h4>'.esc_html__( "Divi Nitro video documentation", 'divi-machine' ).'</h4>
<iframe width="560" height="315" src="https://www.youtube.com/embed/ds_iCldaiwE" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
<h4>Divi BodyCommerce video documentation</h4>
<iframe width="560" height="315" src="https://www.youtube.com/embed/U9gPHMvQ2Js" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
'
) );
$welcometab->createOption( array(
'name' => ''.esc_html__( "Feedback", 'divi-machine' ).'',
'type' => 'heading',
) );
$welcometab->createOption( array(
'type' => 'note',
'desc' => ''.esc_html__( "We would love to hear from you, good or bad! We would really appreciate it if you could leave a review on our product page so that it helps others!", 'divi-machine' ).''
) );

$welcometab->createOption( array(
'name' => ''.esc_html__( "Got an idea?", 'divi-machine' ).'',
'type' => 'heading',
) );
$welcometab->createOption( array(
'type' => 'note',
'desc' => ''.esc_html__( "If you have an idea or would like us to implement a feature that you would benefit from, please dont hesitate to contact us about it", 'divi-machine' ).' <a href="https://diviengine.com/contact/" target="_blank">'.esc_html__( "here", 'divi-machine' ).'</a> '.esc_html__( "as we really want to make all our plugins better for everyone!", 'divi-machine' ).''
) );
}
else {
  # code...
}



///////////////////////////////////////////////////////
// ET PB LAYOUT SETTINGS
///////////////////////////////////////////////////////
// $divi_layout_post = $titan->createMetaBox( array(
//        'name'      => ''.esc_html__( "Divi Machine", 'divi-machine' ).'',
//        'post_type' => array('et_pb_layout' ),
//        'priority'  => 'high',
//        'context' => 'side',
//    ) );
//
//    $divi_layout_post->createOption( array(
//    'name' => ''.esc_html__( "Layout type", 'divi-machine' ).'',
//    'id' => 'dmach_layout_type',
//    'type' => 'select',
//    'options' => array(
//    'normal' => 'Normal',
//    'custom-loop' => 'Custom Loop Layout',
//    ),
//    'default' => 'normal',
//    'desc' => ''.esc_html__( "If you are designing a custom loop layout, enable the 'Custom Loop Layout' setting to get a better preview of how it will look.", 'divi-machine' ).'',
//    ) );

///////////////////////////////////////////////////////
// POST TYPE SECTION
///////////////////////////////////////////////////////
$dmach_post = $titan->createMetaBox( array(
       'name'      => ''.esc_html__( "General Settings", 'divi-machine' ).'',
       'post_type' => array('dmach_post' ),
       'priority'  => 'low'
   ) );



   $dmach_post->createOption( array(
   'name' => ''.esc_html__( "Post Type Name", 'divi-machine' ).'',
   'id' => 'dmach_name_singular',
   'type' => 'text',
   'default' => '',
   'desc' => ''.esc_html__( "Set unique name for your post type. Eg. `Projects`", 'divi-machine' ).'',
   ) );

$dmach_post->createOption( array(
'name' => ''.esc_html__( "Post Type Slug", 'divi-machine' ).'',
'id' => 'dmach_post_type_key',
'type' => 'text',
'default' => '',
'desc' => ''.esc_html__( "Set slug for your post type. Slug should contain only letters, numbers and `-` or `_` chars", 'divi-machine' ).'',
) );

$dmach_post->createOption( array(
'name' => ''.esc_html__( "Description", 'divi-machine' ).'',
'id' => 'dmach_description',
'type' => 'text',
'default' => '',
'desc' => ''.esc_html__( "A short descriptive summary of the post type.", 'divi-machine' ).'',
) );


///////////////////////////////////////////////////////
// LABELS SECTION
///////////////////////////////////////////////////////
$dmach_labels = $titan->createMetaBox( array(
       'name'      => ''.esc_html__( "Labels", 'divi-machine' ).'',
       'post_type' => array('dmach_post' ),
       'priority'  => 'low'
   ) );


   $dmach_labels->createOption( array(
   'name' => ''.esc_html__( "Name (Plural)", 'divi-machine' ).'',
   'id' => 'dmach_name_plural',
   'type' => 'text',
   'default' => '',
   'desc' => ''.esc_html__( "Post type plural name. e.g. Products, Events or Movies.", 'divi-machine' ).'',
   ) );
$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Menu Name", 'divi-machine' ).'',
'id' => 'dmach_menu_name',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Admin Bar Name", 'divi-machine' ).'',
'id' => 'dmach_admin_bar_name',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "All Items", 'divi-machine' ).'',
'id' => 'dmach_all_items',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Add New Item", 'divi-machine' ).'',
'id' => 'dmach_add_new_item',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Add New", 'divi-machine' ).'',
'id' => 'dmach_add_new',
'type' => 'text',
'default' => 'Add New',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "New Item", 'divi-machine' ).'',
'id' => 'dmach_new_item',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Edit Item", 'divi-machine' ).'',
'id' => 'dmach_edit_item',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Update Item", 'divi-machine' ).'',
'id' => 'dmach_update_item',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "View Item", 'divi-machine' ).'',
'id' => 'dmach_view_item',
'type' => 'text',
'default' => '',
) );

$dmach_labels->createOption( array(
'name' => ''.esc_html__( "Search Item", 'divi-machine' ).'',
'id' => 'dmach_search_item',
'type' => 'text',
'default' => '',
) );

   ///////////////////////////////////////////////////////
   // VISIBILITY SECTION
   ///////////////////////////////////////////////////////
   $dmach_visibilty = $titan->createMetaBox( array(
          'name'      => ''.esc_html__( "Post Visibility", 'divi-machine' ).'',
          'post_type' => array('dmach_post' ),
          'priority'  => 'low'
      ) );

   $dmach_visibilty->createOption( array(
   'name' => ''.esc_html__( "Public", 'divi-machine' ).'',
   'id' => 'dmach_public',
   'type' => 'enable',
   'default' => true,
   'desc' => ''.esc_html__( "Show post type in the admin UI.", 'divi-machine' ).'',
   ) );

// $dmach_visibilty->createOption( array(
// 'name' => ''.esc_html__( "Show UI", 'divi-machine' ).'',
// 'id' => 'dmach_show_ui',
// 'type' => 'select',
// 'type' => 'enable',
// 'default' => false,
// 'desc' => ''.esc_html__( "Show post type UI in the admin.", 'divi-machine' ).'',
// ) );

$dmach_visibilty->createOption( array(
'name' => ''.esc_html__( "Show in Admin Sidebar", 'divi-machine' ).'',
'id' => 'dmach_show_in_admin_sidebar',
'type' => 'enable',
'default' => true,
'desc' => ''.esc_html__( "Show post type in admin sidebar.", 'divi-machine' ).'',
) );

$dmach_visibilty->createOption( array(
'name' => ''.esc_html__( "Show in Admin Sidebar Position", 'divi-machine' ).'',
'id' => 'dmach_show_admin_sidebar_postion',
'type' => 'select',
'options' => array(
'5' => '5 - below Posts',
'10' => '10 - below Posts',
'15' => '15 - below Links',
'20' => '20 - below Pages',
'25' => '25 - below Comments',
'60' => '60 - below first separator',
'65' => '65 - below Plugins',
'70' => '70 - below Users',
'75' => '75 - below Tools',
'80' => '80 - below Settings',
'100' => '100 - below second separator',
),
'default' => '5',
'desc' => ''.esc_html__( "Show post type in admin sidebar position.", 'divi-machine' ).'',
) );

$dmach_visibilty->createOption( array(
'name' => ''.esc_html__( "Admin Sidebar Icon", 'divi-machine' ).'',
'id' => 'dmach_show_admin_sidebar_icon',
'type' => 'text',
'default' => 'dashicons-menu',
'desc' => ''.esc_html__( "Post type icon. Use ", 'divi-machine' ).'<a href="https://developer.wordpress.org/resource/dashicons/" target="_blank"> '.esc_html__( "dashicon name", 'divi-machine' ).'</a>.',
) );

$dmach_visibilty->createOption( array(
'name' => ''.esc_html__( "Show in Admin Bar", 'divi-machine' ).'',
'id' => 'dmach_show_in_admin_bar',
'type' => 'enable',
'default' => true,
'desc' => ''.esc_html__( "Show post type in admin bar.", 'divi-machine' ).'',
) );

$dmach_visibilty->createOption( array(
'name' => ''.esc_html__( "Show in Navigation Menus", 'divi-machine' ).'',
'id' => 'dmach_show_in_nav_menus',
'type' => 'enable',
'default' => true,
'desc' => ''.esc_html__( "Show post type in Navigation Menus.", 'divi-machine' ).'',
) );


///////////////////////////////////////////////////////
// OPTIONS SECTION
///////////////////////////////////////////////////////
$dmach_options = $titan->createMetaBox( array(
       'name'      => ''.esc_html__( "Advanced Options", 'divi-machine' ).'',
       'post_type' => array('dmach_post' ),
       'priority'  => 'low'
   ) );

   $dmach_options->createOption( array(
   'name' => ''.esc_html__( "Taxonomies", 'divi-machine' ).'',
   'id' => 'dmach_taxonomies',
   'type' => 'multicheck',
   'options' => array(
       'category' => 'Categories',
       'tag' => 'Tags',
   ),
   'default' => array( 'category', 'tag' ),
   'desc' => ''.esc_html__( "Comma-separated list of Taxonomies. These are the things you want for example you may want categories, tags, topics etc..", 'divi-machine' ).'',
   ) );

   $dmach_options->createOption( array(
       'name' => 'Supports',
       'id' => 'dmach_supports',
       'type' => 'multicheck',
       'desc' => 'Check what you want the custom post to support',
       'options' => array(
           'title' => 'Title',
           'editor' => 'Content (editor)',
           'author' => 'Excerpt',
           'excerpt' => 'Author',
           'thumbnail' => 'Featured Image',
           'comments' => 'Comments',
           'trackbacks' => 'Trackbacks',
           'revisions' => 'Revisions',
           'custom-fields' => 'Custom Fields',
           'page-attributes' => 'Page Attributes',
           'post-formats' => 'Post Formats',
       ),
       'default' => array( 'title', 'editor', 'thumbnail', 'custom-fields', 'page-attributes' ),
   ) );

   $dmach_options->createOption( array(
   'name' => ''.esc_html__( "Exclude From Search", 'divi-machine' ).'',
   'id' => 'dmach_exclude_from_search',
   'type' => 'enable',
   'default' => false,
   'desc' => ''.esc_html__( "Posts of this type should be excluded from search results.", 'divi-machine' ).'',
   ) );

   $dmach_options->createOption( array(
   'name' => ''.esc_html__( "Enable Archives", 'divi-machine' ).'',
   'id' => 'dmach_enable_archives',
   'type' => 'select',
   'options' => array(
   'true' => 'Yes (use default slug)',
   'true_custom' => 'Yes (set a custom archive slug - below)',
   'false' => 'No (prevent archive pages)',
   ),
   'default' => 'true',
   'desc' => ''.esc_html__( "Enables post type archives. Post type key is used as default archive slug.", 'divi-machine' ).'',
   ) );

   $dmach_options->createOption( array(
   'name' => ''.esc_html__( "Custom Archive Slug", 'divi-machine' ).'',
   'id' => 'dmach_custom_archive_slug',
   'type' => 'text',
   'desc' => ''.esc_html__( "Set custom archive slug.", 'divi-machine' ).'',
   ) );


   $dmach_options->createOption( array(
   'name' => ''.esc_html__( "Hierarchical", 'divi-machine' ).'',
   'id' => 'dmach_hierarchical',
   'type' => 'enable',
   'default' => true,
   'desc' => '​If you want your posts to have descendants (like pages) where you have parent and children posts - enable this.',
   ) );

///////////////////////////////////////////////////////
// Query SECTION
///////////////////////////////////////////////////////
// $dmach_query = $titan->createMetaBox( array(
//        'name'      => ''.esc_html__( "Query", 'divi-machine' ).'',
//        'post_type' => array('dmach_post' ),
//        'priority'  => 'low'
//    ) );

   //
   // $dmach_query->createOption( array(
   // 'name' => ''.esc_html__( "Query", 'divi-machine' ).'',
   // 'id' => 'dmach_query',
   // 'type' => 'select',
   // 'options' => array(
   // 'default' => 'Default (post type key)',
   // 'custom' => 'Custom query variable',
   // ),
   // 'default' => 'default',
   // 'desc' => ''.esc_html__( "Direct query variable used in WP_Query.", 'divi-machine' ).'',
   // ) );
   //
   // $dmach_query->createOption( array(
   // 'name' => ''.esc_html__( "Custom Query", 'divi-machine' ).'',
   // 'id' => 'dmach_custom_query',
   // 'type' => 'text',
   // 'desc' => ''.esc_html__( "Custom query variable.", 'divi-machine' ).'',
   // ) );

   //
   // ///////////////////////////////////////////////////////
   // // Permalink SECTION
   // ///////////////////////////////////////////////////////
   // $dmach_permalink = $titan->createMetaBox( array(
   //        'name'      => ''.esc_html__( "Query & Capabilitites", 'divi-machine' ).'',
   //        'post_type' => array('dmach_post' ),
   //        'priority'  => 'low'
   //    ) );
   //
   //    $dmach_permalink->createOption( array(
   //    'name' => ''.esc_html__( "Publicly Queryable", 'divi-machine' ).'',
   //    'id' => 'dmach_public_query',
   //    'type' => 'enable',
   //    'default' => true,
   //    'desc' => ''.esc_html__( "Enable front end queries as part of parse_request().", 'divi-machine' ).'',
   //    ) );
   //
   //    // $dmach_permalink->createOption( array(
   //    // 'name' => ''.esc_html__( "Permalink Rewrite", 'divi-machine' ).'',
   //    // 'id' => 'dmach_permalinks_rewrite',
   //    // 'type' => 'select',
   //    // 'options' => array(
   //    // 'none' => 'No permalink (prevent URL rewriting)',
   //    // 'default' => 'Default permalinks (post type key)',
   //    // ),
   //    // 'default' => 'default',
   //    // 'desc' => ''.esc_html__( "Use Default Permalinks (using post type key), prevent automatic URL rewriting (no pretty permalinks), or set custom permalinks.", 'divi-machine' ).'',
   //    // ) );
   //
   //    $dmach_permalink->createOption( array(
   //    'name' => ''.esc_html__( "Capability Type", 'divi-machine' ).'',
   //    'id' => 'dmach_capability_type',
   //    'type' => 'select',
   //    'options' => array(
   //    'post' => 'Same as Posts',
   //    'page' => 'Same as Pages',
   //    ),
   //    'default' => 'page',
   //    'desc' => ''.esc_html__( "Used as a base to construct capabilities.", 'divi-machine' ).'',
   //    ) );




   $machine_settings_admin = $titan->createAdminPanel( array( 'name' => 'Machine Settings', 'id' => 'divi-machine-settings', 'parent' => 'divi-engine', 'position' => '1') );
   $settingstab = $machine_settings_admin->createTab( array('name' => ''.esc_html__( "General Settings", 'divi-machine' ).'',) );
   $licensestab = $machine_settings_admin->createTab( array('name' => ''.esc_html__( "License", 'divi-machine' ).'',) );
   $helptab = $machine_settings_admin->createTab( array('name' => ''.esc_html__( "Get Help", 'divi-machine' ).'',) );

   $helptab->createOption(array(
       'name' => 'Get Help',
       'type' => 'heading',
   ));

   $helptab->createOption( array(
   'type' => 'note',
   'desc' => ''.esc_html__( "Divi Machine is a very powerful plugin, but with great power comes.... complex settings :D At first it may seem overwhelming but we assure you that once you understand the concept, it will speed up your developemnt time and save you so much money in the long run.", 'divi-machine' ).''
   ) );

   $helptab->createOption( array(
   'type' => 'note',
   'desc' => '<h4>We have video documentation where you can <a href="#" target="_blank">watch us build a car listing website from scratch to finish here.</a><br>
   If you do not want to watch the whole documentation, then we think the main things you need to understand are:</h4>
   <h4>'.esc_html__( "Overview", 'divi-machine' ).'</h4>
   <iframe width="560" height="315" src="https://www.youtube.com/embed/ds_iCldaiwE" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
   <h4>Custom Loop Layout</h4>
   <iframe width="560" height="315" src="https://www.youtube.com/embed/U9gPHMvQ2Js" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
   '
   ) );

   $helptab->createOption( array(
   'type' => 'note',
   'desc' => 'We also have <a href="#" target="_blank">written documentation</a> which will be more up to date when we change and add more features so be sure to check this out. We are also available on support by emailing support@diviengine.com.<br>
   We do hope you love the plugin and that it helps you on your web design adventures.'
   ) );

   /// GENERAL SETTINGS


   $settingstab->createOption( array(
   'type' => 'save',
   ) );

   $settingstab->createOption(array(
       'name' => 'General Settings',
       'type' => 'heading',
   ));

   $settingstab->createOption( array(
   'name' => ''.esc_html__( 'Enable Debug Mode?', 'divi-machine' ).'',
   'id' => 'enable_debug',
   'type' => 'enable',
   'default' => false,
   'enabled' => ''.esc_html__( 'YES', 'divi-machine' ).'',
   'disabled' => ''.esc_html__( 'NO', 'divi-machine' ).'',
   'desc' => ''.esc_html__( 'If support staff has asked you to enable debug, enable this.', 'divi-machine' ).'',
   ) );

   $settingstab->createOption( array(
   'name' => ''.esc_html__( "Add some custom CSS/JS (great when exporting/importing settings)", 'divi-machine' ).'',
   'type' => 'heading',
   ) );

   $settingstab->createOption( array(
       'name' => ''.esc_html__( "Custom CSS", 'divi-machine' ).'',
       'id' => 'machine_custom_css',
       'type' => 'code',
       'desc' => ''.esc_html__( "Put your custom CSS rules here. Do not put <style> tags as we will do this for you. We will automatically minify your CSS so no need to minify it here.", 'divi-machine' ).'',
       'lang' => 'css',
   ) );


   $settingstab->createOption( array(
       'name' => ''.esc_html__( "Custom JavaScript", 'divi-machine' ).'',
       'id' => 'machine_custom_js',
       'type' => 'code',
       'desc' => ''.esc_html__( "Put your additional javascript rules here. Dont forget to add your <script> tags as this allows you to add multiple for yourself.", 'divi-machine' ).'',
       'lang' => 'javascript',
   ) );

   $settingstab->createOption( array(
   'name' => ''.esc_html__( 'Import/Export Settings', 'divi-machine' ).'',
   'type' => 'heading',
   ) );

   $settingstab->createOption( array(
   'desc' => ''.esc_html__( 'Here you can export and import the settings of Divi Machine.', 'divi-machine' ).'',
   'type' => 'note',
   ) );


   $settingstab->createOption(array(
       'name' => 'Upload your setting file',
       'id' => 'setting_file_upload',
       'type' => 'file',
       'label' => 'Choose File',
       'placeholder' => 'Choose File'
   ));
   $settingstab->createOption(array(
       'id' => "import_setting_btn",
       'name' => 'Import Settings',
       'type' => 'ajax-button',
       'action' => 'divi_machine_import_action',
       'label' => __('Save Settings', 'default'),
       'data_filter_callback' => 'import_settings_data_filter_callback',
       'success_callback' => 'import_settings',
       'class' => array('button-primary', 'button-secondary')
   ));
   $settingstab->createOption(array(
       'name' => 'Export Settings',
       'type' => 'ajax-button',
       'action' => 'divi_machine_export_action',
       'label' => __('Download', 'default'),
       'success_callback' => 'export_settings',
       'class' => array('button-primary', 'button-secondary')
   ));

   $settingstab->createOption( array(
   'type' => 'save',
   ) );


   /// LICENSE


   $licensestab->createOption(array(
       'name' => 'Divi Machine Software License',
       'type' => 'heading',
   ));


   if (isset($_GET['page']) && ($_GET['page'] == 'divi-machine-settings')) { // phpcs:ignore
   $de_dmach_option = new DE_DMACH_options_interface();

   $licensestab->createOption(array(
       'type' => 'custom',
       'custom' => $de_dmach_option->admin_menu(),
   ));

       add_action('init', array($de_dmach_option, 'options_update'), 1);
   }



}
add_action( 'tf_create_options', 'divi_machine_options' );

//Setting Code Start
add_action('wp_ajax_divi_machine_export_action', 'divi_machine_export_action');

function divi_machine_export_action() {
    // Do something
    $mydata = get_option('divi-machine_options');
    $mydata = unserialize($mydata);
    $export_data = [];
    foreach ($mydata as $key => $value) {
      $data_val = str_ireplace("\n", "<br/>", $value);
      $export_data[] = array($key, $data_val);
    }

    wp_send_json_success(__($export_data, 'default'));
}

add_action('wp_ajax_divi_machine_import_action', 'divi_machine_import_action');

function divi_machine_import_action() {
  $setting_csv = file_get_contents(wp_get_attachment_url($_REQUEST['file_id'])); // phpcs:ignore
  $lines = explode("\n", $setting_csv); // split data by new lines
  $linevalues = [];
  foreach ($lines as $i => $line) {

      $values = explode(',', $line);
      $key = $values[0];
      $value = $values[1];
      if (count($values) > 2) {
          unset($values[0]);
          $value = implode($values, ",");
          $value = trim( $value,'"');
      }
      $linevalues[$key] = str_ireplace( "<br/>", "\n", trim($value, '"') );
  }

  $linevalues = serialize($linevalues);

  update_option('divi-machine_options', $linevalues);
  wp_send_json_success(__('Successfully imported', 'default'));
}

?>
