<?php
if ( ! defined( 'ABSPATH' ) ) exit;

function divi_machine_filterposts_handler() {

  include(DE_DMACH_PATH . '/titan-framework/titan-framework-embedder.php');
  $titan = TitanFramework::getInstance( 'divi-machine' );
  $enable_debug = $titan->getOption( 'enable_debug' );


    global $wp_query, $wpdb, $post, $woocommerce;

    ////
    $filter_item_id = esc_attr( $_POST['filter_item_id'] );
    $filter_item_name = esc_attr( $_POST['filter_item_name'] );
    $filter_item_val = esc_attr( $_POST['filter_item_val'] );
    $filter_input_type = esc_attr( $_POST['filter_input_type'] );

    $filter_item_id_array = array_map('trim',explode(', ', $filter_item_id));
    $filter_item_name_array = array_map('trim',explode(', ', $filter_item_name));
    $filter_item_val_array = array_map('trim',explode(', ', $filter_item_val));
    $filter_input_type_array = array_map('trim',explode(', ', $filter_input_type));

    $filter_name_and_val_array = array_combine($filter_item_name_array, $filter_item_val_array);

    $all_filters_array = array_map(function ($filter_item_id_array, $filter_item_name_array, $filter_item_val_array, $filter_input_type_array) {
        return array_combine(
            ['filter_item_id', 'filter_item_name', 'filter_item_val', 'filter_input_type'],
            [$filter_item_id_array, $filter_item_name_array, $filter_item_val_array, $filter_input_type_array]
        );
    }, $filter_item_id_array, $filter_item_name_array, $filter_item_val_array, $filter_input_type_array);

    ////

    ob_start();

    $layoutid = esc_attr( $_POST['layoutid'] );
    $posttype = esc_attr( $_POST['posttype'] );
    $noresults = esc_attr( $_POST['noresults'] );
    $sortorder = esc_attr( $_POST['sortorder'] );
    $sortasc = esc_attr( $_POST['sortasc'] );
    $gridstyle = esc_attr( $_POST['gridstyle'] );
    $columnscount = esc_attr( $_POST['columnscount'] );
    $postnumber = esc_attr( $_POST['postnumber'] );
    $loadmore = esc_attr( $_POST['loadmore'] );
    $loadmoretext = esc_attr( $_POST['loadmoretext'] );
    $loadmoretextloading = esc_attr( $_POST['loadmoretextloading'] );
    $posttax = esc_attr( $_POST['posttax'] );
    $postterm = esc_attr( $_POST['postterm'] );
    $current_page = esc_attr( $_POST['current_page'] );

    $meta_query = array('relation' => 'AND');

    $args_url_acf = [];

    if (isset($_POST['data_fields'])) {
        foreach($_POST['data_fields'] as $items)
        {
            foreach($items as $item ) {
                foreach($item as $key => $value) {
                    if ( isset($value['val']) && $value['val'] != "")  {
                        if (substr($value['name'], -9) == '_category') {

                            if ( $value['val'] != 'all' ) {
                                $cat_show = $value['val'];
                            } else {
                                $cat_show = "all";
                            }

                        } else if ($value['name'] == "post_tag") {
                            if ( $value['val'] != 'all' ) {
                                $post_tag_show = $value['val'];
                            } else {
                                $post_tag_show = "all";
                            }
                        } else if ($value['name'] == "tags") {
                            if ( $value['val'] != 'all' ) {
                                $tag_show = $value['val'];
                            } else {
                                $tag_show = "all";
                            }
                        } else {
                            if ($value['name'] == "s") {
                                $search_keyword = $value['val'];
                            } else if ($value['name'] == "category") { // if post category
                              $post_category = $value['val'];
                            } else {

                              if ($value['type'] == "radio") {
                                $meta_query[] = array(
                                    'key' => $value['name'],
                                    'value' => $value['val'],
                                    'compare' => 'LIKE'
                                );
                              } else if ($value['type'] == "range") {

    $price_value = (explode(";",$value['val']));

    if ( sizeof( $price_value ) == 1 ){
        $meta_query[] = array(
            'key' => $value['name'],
            'value' => $price_value[0],
            'type' => 'NUMERIC',
            'compare' => '<='
        );
    }else{
    $meta_query[] = array(
        'key' => $value['name'],
        'value' => $price_value,
        'compare' => 'BETWEEN',
        'type' => 'NUMERIC'
    );
    }

                              } else {
                                $meta_query[] = array(
                                    'key' => $value['name'],
                                    'value' => $value['val'],
                                    'compare' => 'IN'
                                );
                              }

                                $args_url_acf[$value['name']] = $value['val'];
                            }
                        }
                    }
                }
            }
        }
    }

    //////////////////////////////////////////////


    //////////////////////////////////////////////

    $args_url = array(
        'post_type' => $posttype,
        'post_status' => 'publish',
        'posts_per_page' => $postnumber,
        'orderby' => $sortorder,
        'order' => $sortasc
    );

    $args_url_final = array_merge($args_url, $args_url_acf);

    // $args_url_final_send = add_query_arg( $args_url_final, 'http://localhost/divi-machine/' );
    // echo $args_url_final_send;

    if ($sortorder == "date" || $sortorder == "relevance") {
        $args = array(
            'post_type' => $posttype,
            'post_status' => 'publish',
            'posts_per_page' => $postnumber,
            'orderby' => $sortorder,
            'order' => $sortasc,
            'meta_query' => $meta_query
        );
    } else {
        $args = array(
            'post_type' => $posttype,
            'post_status' => 'publish',
            'posts_per_page' => $postnumber,
            'meta_key'			=> $sortorder,
            'orderby'			=> 'meta_value',
            'order' => $sortasc,
            'meta_query' => $meta_query
        );
    }

    if (isset($cat_show)){
        if ($cat_show != "all"){
            $ending = "_category";
            $cat_key = $posttype . $ending;

            $args['tax_query'] = array(
                array(
                    'taxonomy'  => $cat_key,
                    'field'     => 'slug',
                    'terms'     => $cat_show,
                    'operator' => 'IN'
                )
            );
        }
    }

    if (isset($tag_show)){
        if ($tag_show != "all"){

            $prefix = 'tag-link-';
            $str = $tag_show;

            if (substr($str, 0, strlen($prefix)) == $prefix) {
                $str = substr($str, strlen($prefix));
            }
            $args['tag__in'] = $str;
        }
    }

    if (isset($search_keyword)) {
        $args['s'] = $search_keyword;
    }

    if (isset($posttax) && $posttax !== "") {
        $args['tax_query'] = array(
            array(
                'taxonomy'  => $posttax,
                'field'     => 'slug',
                'terms'     => $postterm,
                'operator' => 'IN'
            )
        );
    }

    if (isset($post_category)) {
      $args['category_name'] = $post_category;
    }

    if (isset($post_tag_show)) {
      $args['tag'] = $post_tag_show;
    }



    $args = apply_filters('dmach_archive_post_args', $args);

    query_posts( $args );

if ($enable_debug == "1") {
    ?>
  <div class="reporting_args hidethis" style="white-space: pre;">
        <?php  print_r($args); ?>
  </div>
    <?php
  }

    $loadmore_param = array(
        'post_var' => json_encode( $wp_query->query_vars ),
        'max_num_pages' => $wp_query->max_num_pages,
        'current_page'  => $current_page
    );

    $filter_item_name_array_removeduplicates = array_unique($filter_name_and_val_array);
    $filter_item_name_collate =[];

    if ( have_posts() ) {
?>
      <div class="grid-posts loop-grid">
<?php
        while ( have_posts() ) {
            the_post();
            if ($gridstyle == "masonry") {
?>
    <div class="grid-item">
        <div class="grid-item-cont">
<?php
            } else {
?>
    <div class="grid-col">
        <div class="grid-item-cont">
<?php
            }

            $post = get_post( get_the_ID() );

            setup_postdata( $post );

            $meta = get_post_meta( get_the_ID() );
            $post_tags = get_the_tags( get_the_ID() );
if ($enable_debug == "1") {
            print_r( $post_tags );
}
            foreach ($filter_name_and_val_array as $key => $value ) {

                // check meta for refine filters
                if( array_key_exists( $key , $meta ) )
                {

                    $meta_get = get_post_meta( get_the_ID(), $key, true );

                    if(array_key_exists($key, $filter_item_name_collate)){
                        $filter_item_name_collate[$key][] = $meta_get;
                    } else {
                        $filter_item_name_collate[$key] = array($meta_get);
                    }
                }
            }

            echo apply_filters('the_content', get_post_field('post_content', $layoutid));
?>
        </div>
    </div>
<?php
        }

        if ($loadmore == "on") {
            if (  $wp_query->max_num_pages > 1 ){
?>
    <div class="dmach-loadmore et_pb_button" data-btntext="<?php echo $loadmoretext ?>" data-btntext_loading="<?php echo $loadmoretextloading ?>"><?php echo $loadmoretext ?></div>
<?php
            }
        }

        ?>
      </div>
      <?php

        wp_reset_query();

    } else {
        if ($noresults == "none") {
            echo "No " . $posttype;
        } else {
?>

    <div class="no-results-layout">
    <?php echo do_shortcode('[et_pb_row global_module="' . $noresults . '"][/et_pb_row]'); ?>
    </div>

<?php
        }
    }

    $posts = ob_get_contents();
    ob_end_clean();

    ob_start();

    // retrieve the styles for the modules
    $internal_style = ET_Builder_Element::get_style();
    // reset all the attributes after we retrieved styles
    ET_Builder_Element::clean_internal_modules_styles( false );
    $et_pb_rendering_column_content = false;

    // append styles
    if ( $internal_style ) {
?>
    <div class="dmach-inner-styles">
<?php
        $cleaned_styles = str_replace("#et-boc .et-l","#et-boc .et-l .filtered-posts", $internal_style);
        $cleaned_styles = str_replace(".et_pb_section_",".filtered-posts .et_pb_section_", $cleaned_styles);
        $cleaned_styles = str_replace(".et_pb_row_",".filtered-posts .et_pb_row_", $cleaned_styles);
        $cleaned_styles = str_replace(".et_pb_module_",".filtered-posts .et_pb_module_", $cleaned_styles);
        $cleaned_styles = str_replace(".et_pb_column_",".filtered-posts .et_pb_column_", $cleaned_styles);
        $cleaned_styles = str_replace(".et_pb_de_mach_",".filtered-posts .et_pb_de_mach_", $cleaned_styles);
        $cleaned_styles = str_replace(".filtered-posts .filtered-posts",".filtered-posts", $cleaned_styles);
        $cleaned_styles = str_replace(".filtered-posts .et_pb_section .filtered-posts",".filtered-posts", $cleaned_styles);

        printf(
            '<style type="text/css" class="dmach_ajax_inner_styles">
              .filtered-posts .grid-col div.et_pb_section {background-color: transparent;background-image: inherit !important;}
              %1$s
            </style>',
            et_core_esc_previously( $cleaned_styles )
        );
?>
    </div>
<?php
    }

    $css_output = ob_get_contents();

    ob_end_clean();

    ///////////////////////////////////////////////////////////////////
    // FILTERS
    //////////////////////////////////////////////////////////////////

    ob_start();
?>
    <div class="refine-filters">
<?php
    foreach($filter_item_name_collate as $key => $item) {
        $filter_val = '';
        foreach($item as $value) {
            $single_val = '';
            if ( is_array( $value ) ){
                $single_val = implode( ',', $value );
            }else{
                $single_val = $value;
            }

            if ( $filter_val == '' ){
                $filter_val = $single_val;
            }else{
                $filter_val = $filter_val . ',' . $single_val;
            }
        }
?>
        <span class="active-filters" data-filter-name="<?php echo $key?>" data-filter-val="<?php echo $filter_val;?>"></span>
<?php
    }
?>

    <script>
        dmach_remove_filters();
    </script>
    </div>

<?php if ($enable_debug == "1") { ?>
    <div class="reporting_args hidethis" style="white-space: pre;">
        <?php print_r($filter_item_name_collate); ?>
    </div>
  <?php } ?>

<?php
    $filers_html = ob_get_contents();
    ob_end_clean();

    $return = array(
        'posts' => $posts,
        'filters' =>$filers_html,
        'loadmore_param' => $loadmore_param,
        'css_output' => $css_output
    );

    wp_send_json($return);
    wp_die();
}

add_action( 'wp_ajax_divi_machine_filterposts_handler', 'divi_machine_filterposts_handler' );
add_action( 'wp_ajax_nopriv_divi_machine_filterposts_handler', 'divi_machine_filterposts_handler' );


function divi_machine_loadmore_ajax_handler(){

    ob_start();

	// prepare our arguments for the query
	$args = json_decode( stripslashes( $_POST['query'] ), true );
	$args['paged'] = $_POST['page'] + 1; // we need next page to be loaded
	$args['post_status'] = 'publish';
    $layoutid = esc_attr( $_POST['layoutid'] );
    $posttype = esc_attr( $_POST['posttype'] );
    $noresults = esc_attr( $_POST['noresults'] );
    $sortorder = esc_attr( $_POST['sortorder'] );
    $sortasc = esc_attr( $_POST['sortasc'] );
    $gridstyle = esc_attr( $_POST['gridstyle'] );
    $columnscount = esc_attr( $_POST['columnscount'] );
    $postnumber = esc_attr( $_POST['postnumber'] );
    $args['posts_per_page'] = $postnumber;
	// it is always better to use WP_Query but not here
	query_posts( $args );

	if( have_posts() ) :
        global $wp_query, $wpdb, $post, $woocommerce;

		// run the loop
		while( have_posts() ):
            the_post();
            if ($gridstyle == "masonry") {
?>
    <div class="grid-item">
        <div class="grid-item-cont">
<?php
            } else {
?>
    <div class="grid-col">
        <div class="grid-item-cont">
<?php
            }

            echo apply_filters('the_content', get_post_field('post_content', $layoutid));
?>
        </div>
    </div>

<?php
		endwhile;
	endif;

    $posts = ob_get_contents();
    ob_end_clean();

    ob_start();
    // retrieve the styles for the modules
    $internal_style = ET_Builder_Element::get_style();
    // reset all the attributes after we retrieved styles
    ET_Builder_Element::clean_internal_modules_styles( false );
    $et_pb_rendering_column_content = false;

    // append styles
    if ( $internal_style ) {
?>
    <div class="dmach-inner-styles">
<?php



$cleaned_styles = str_replace("#et-boc .et-l","#et-boc .et-l .filtered-posts", $internal_style);
$cleaned_styles = str_replace(".et_pb_section_",".filtered-posts .et_pb_section_", $cleaned_styles);
$cleaned_styles = str_replace(".et_pb_row_",".filtered-posts .et_pb_row_", $cleaned_styles);
$cleaned_styles = str_replace(".et_pb_module_",".filtered-posts .et_pb_module_", $cleaned_styles);
$cleaned_styles = str_replace(".et_pb_column_",".filtered-posts .et_pb_column_", $cleaned_styles);
$cleaned_styles = str_replace(".et_pb_de_mach_",".filtered-posts .et_pb_de_mach_", $cleaned_styles);
$cleaned_styles = str_replace(".filtered-posts .filtered-posts",".filtered-posts", $cleaned_styles);
$cleaned_styles = str_replace(".filtered-posts .et_pb_section .filtered-posts",".filtered-posts", $cleaned_styles);

printf(
    '<style type="text/css" class="dmach_ajax_inner_styles">
      .filtered-posts .grid-col div.et_pb_section {background-color: transparent;background-image: inherit !important;}
      %1$s
    </style>',
    et_core_esc_previously( $cleaned_styles )
        );
?>
    </div>
<?php
    }

    $css_output = ob_get_contents();
    ob_end_clean();

    $return = array(
        'posts' => $posts,
        'css_output' => $css_output
    );

    wp_send_json($return);

	die;
}

add_action('wp_ajax_divi_machine_loadmore_ajax_handler', 'divi_machine_loadmore_ajax_handler');
add_action('wp_ajax_nopriv_divi_machine_loadmore_ajax_handler', 'divi_machine_loadmore_ajax_handler');

?>
