<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class de_mach_acf_item_code extends ET_Builder_Module {

public $vb_support = 'on';

protected $module_credits = array(
  'module_uri' => DE_DMACH_PRODUCT_URL,
  'author'     => DE_DMACH_AUTHOR,
  'author_uri' => DE_DMACH_URL,
);

                function init() {
                    $this->name       = esc_html__( '.ACF Item - Divi Machine', 'divi-machine' );
                    $this->slug = 'et_pb_de_mach_acf_item';
                		$this->child_title_var             = 'custom_identifier';


                    $this->fields_defaults = array(
                    // 'loop_layout'         => array( 'on' ),
                    );

          $this->settings_modal_toggles = array(
      			'general' => array(
      				'toggles' => array(
      					'main_content' => esc_html__( 'Main Options', 'divi-machine' ),
                'specific'        => esc_html__( 'Specific Settings', 'et_builder' ),
                'image'        => esc_html__( 'Image & Icon', 'et_builder' ),
      				),
      			),
      			'advanced' => array(
      				'toggles' => array(
      					'text' => esc_html__( 'Text', 'divi-machine' ),
      				),
      			),

      		);


                      $this->main_css_element = '%%order_class%%';


                      $this->advanced_fields = array(
                  			'fonts' => array(
                  				'title_css' => array(
                  					'label'    => esc_html__( 'Item', 'divi-machine' ),
                  					'css'      => array(
                  						'main' => "%%order_class%% .dmach-acf-item-containter",
                  						'important' => 'all',
                  					),
                  					'font_size' => array(
                  						'default' => '14px',
                  					),
                  					'line_height' => array(
                  						'default' => '1em',
                  					),
                  				),
                    				'label_css' => array(
                    					'label'    => esc_html__( 'Label', 'divi-machine' ),
                    					'css'      => array(
                    						'main' => "%%order_class%% .dmach-acf-label",
                    						'important' => 'all',
                    					),
                    					'font_size' => array(
                    						'default' => '14px',
                    					),
                    					'line_height' => array(
                    						'default' => '1em',
                    					),
                    				),
                      				'text_before_css' => array(
                      					'label'    => esc_html__( 'Before', 'divi-machine' ),
                      					'css'      => array(
                      						'main' => "%%order_class%% .dmach-acf-before",
                      						'important' => 'all',
                      					),
                      					'font_size' => array(
                      						'default' => '14px',
                      					),
                      					'line_height' => array(
                      						'default' => '1em',
                      					),
                      				),
                        				'seperator' => array(
                        					'label'    => esc_html__( 'Seperator', 'divi-machine' ),
                        					'css'      => array(
                        						'main' => "%%order_class%% .dmach-seperator",
                        						'important' => 'all',
                        					),
                        					'font_size' => array(
                        						'default' => '14px',
                        					),
                        					'line_height' => array(
                        						'default' => '1em',
                        					),
                        				),
                  			),


                  			'borders'               => array(
                  				'default' => array(
                  					'css' => array(
                  						'main' => array(
                  							// Accordion Item can use %%parent_class%% because its slug is parent_slug + `_item` suffix
                  							'border_radii'  => "{$this->main_css_element} .dmach-acf-value",
                  							'border_styles' => "{$this->main_css_element} .dmach-acf-value",
                  						)
                  					),
                  				),
                  			),

                  			'margin_padding' => array(
                  				'css' => array(
                  					'important' => 'all',
                  				),
                  			),

              			'background' => array(
              				'settings' => array(
              					'color' => 'alpha',
              				),
              			),
                  			'button' => array(
                      'button' => array(
                        'label' => esc_html__( 'Button', 'et_builder' ),
                        'css' => array(
                          'main' => "{$this->main_css_element} .et_pb_button",
                          'plugin_main' => "{$this->main_css_element}.et_pb_module",
                        ),
                        'box_shadow'  => array(
                          'css' => array(
                            'main' => "{$this->main_css_element} .et_pb_button",
                                'important' => 'all',
                          ),
                        ),
                        'margin_padding' => array(
                        'css'           => array(
                          'main' => "{$this->main_css_element} .et_pb_button",
                          'important' => 'all',
                        ),
                        ),
                      ),
                  			),
                  			'box_shadow' => array(
                  				'default' => array(),
                  				'product' => array(
                  					'label' => esc_html__( 'Default Layout - Box Shadow', 'divi-machine' ),
                  					'css' => array(
                  						'main' => "%%order_class%% .products .product",
                  					),
                  					'option_category' => 'layout',
                  					'tab_slug'        => 'advanced',
                  					'toggle_slug'     => 'product',
                  				),
                  			),
                  		);


                      $this->custom_css_fields = array(
                  			'item' => array(
                  				'label'       => esc_html__( 'Item', 'et_builder' ),
                  				'selector'    => '.dmach-acf-value',
                  			),
                    			'text_before' => array(
                    				'label'       => esc_html__( 'Text Before', 'et_builder' ),
                    				'selector'    => '.dmach-acf-before',
                    			),
                      			'label' => array(
                      				'label'       => esc_html__( 'Label', 'et_builder' ),
                      				'selector'    => '.dmach-acf-label',
                      			),
                        			'image' => array(
                        				'label'       => esc_html__( 'Image', 'et_builder' ),
                        				'selector'    => '.dmach-icon-image-content img',
                        			),
                  		);




            $this->help_videos = array(
            );

              // add_filter( 'et_pb_module_content', array( $this, 'add_acf_item_content' ),10, 6 );
          }

          // function add_acf_item_content( $content, $props, $attrs, $render_slug, $_address, $global_content ){
          //
          //   if ( $render_slug == 'et_pb_de_mach_acf_item'){
          //
          //   $acf_name = $props['acf_name'];
          //   $pretify_text = $props['pretify_text'];
          //   $pretify_seperator = $props['pretify_seperator'];
          //   $prefix = $props['prefix'];
          //   $label_seperator = $props['label_seperator'];
          //
          //   $post_slug = DEDMACH_INIT::get_vb_post_type();
          //
          //     $get_cpt_args = array(
          //       'post_type' => $post_slug,
          //       'post_status' => 'publish',
          //       'posts_per_page' => '1',
          //       'orderby' => 'ID',
          //       'order' => 'ASC',
          //     );
          //
          //     query_posts( $get_cpt_args );
          //
          //     $first = true;
          //
          //     if ( have_posts() ) {
          //     while ( have_posts() ) {
          //       the_post();
          //       // setup_postdata( $post );
          //
          //         if ( $first )  {
          //
          //           //////////////////////////////////////////////////
          //
          //           $get_id = get_the_ID();
          //           $get_title = get_the_title();
          //           if( isset($acf_name) && $acf_name !== 'none') {
          //
          //             // $acf_value = get_field($acf_name, $get_id);
          //             $acf_get = get_field_object($acf_name);
          //             $acf_type = $acf_get['type'];
          //
          //             if ($pretify_text == "on" && ( $acf_type == 'number' || $acf_type == 'range' )) {
          //               $item_value_before = number_format( $acf_get['value'] , 0 , '.' , ',' );
          //               $item_value = str_replace(',', $pretify_seperator, $item_value_before);
          //             } else {
          //               $item_value = $acf_get['value'];
          //             }
          //
          //             $show_label_dis =  $acf_get['label'] . $label_seperator;
          //             $show_label_dis = '<span class="dmach-acf-label">' . $show_label_dis . '</span>';
          //
          //
          //             $contents = $show_label_dis . $prefix . $item_value;
          //
          //
          //           } else {
          //             $contents = 'Please select an ACF field you have created';
          //           }
          //
          //         //////////////////////////////////////////////////
          //           $first = false;
          //         } else {
          //
          //         }
          //
          //       }
          //     }
          //
          //           $content = $contents;
          //         }
          //
          //         return $content;
          //
          // }

                  function get_fields() {
                		$et_accent_color = et_builder_accent_color();

                    $acf_fields = DEDMACH_INIT::get_acf_fields();

                    ///////////////////////////////
                    $sizes = get_intermediate_image_sizes();
                            foreach ($sizes as $size) {
                                $options[$size] = $size;
                            }


                //////////////////////////////
                  $fields = array(
                    'custom_identifier' => array(
                        'label'       => __( 'Repeater Custom Label', 'divi-bodyshop-woocommerce' ),
                        'type'        => 'text',
                        'toggle_slug'     => 'main_content',
                        'default'         => 'ACF Item',
                        'option_category'   => 'configuration',
                        'description' => __( 'This will change the label of the item inside the repeater module for easy identification.', 'divi-bodyshop-woocommerce' ),
                    ),
                  'acf_name' => array(
                  'toggle_slug'       => 'main_content',
                    'label'             => esc_html__( 'ACF Name', 'divi-machine' ),
                    'type'              => 'select',
                    'options'           => $acf_fields,
                    'default'           => 'none',
            				'computed_affects' => array(
            					'__getacfitem',
            				),
                    'option_category'   => 'configuration',
                    'description'       => esc_html__( 'Add the name of the ACF you want to display here', 'divi-machine' ),
                  ),
                      'show_label' => array(
                      'toggle_slug'       => 'main_content',
                        'label' => esc_html__( 'Show Label', 'divi-machine' ),
                        'type' => 'yes_no_button',
                        'options_category' => 'configuration',
                        'options' => array(
                          'on' => esc_html__( 'Yes', 'divi-machine' ),
                          'off' => esc_html__( 'No', 'divi-machine' ),
                        ),
                				'affects'         => array(
                					'label_seperator',
                          'custom_label'
                				),
                        'default' => 'on',
                        'description' => esc_html__( 'Enable this if you want to show the label of the ACF item.', 'divi-machine' )
                      ),
                      'custom_label' => array(
                      'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Custom label (leave blank for default label)', 'divi-machine' ),
                        'type'              => 'text',
                        'option_category'   => 'configuration',
                        'depends_show_if'   => 'on',
                				'computed_affects' => array(
                					'__getacfitem',
                				),
                        'description'       => esc_html__( 'Add a custom label here or leave it blank to get the default label.', 'divi-machine' ),
                      ),
                          'pretify_text' => array(
                          'toggle_slug'       => 'main_content',
                            'label' => esc_html__( 'Prettify Your text?', 'divi-machine' ),
                            'type' => 'yes_no_button',
                            'options_category' => 'configuration',
                    				'computed_affects' => array(
                    					'__getacfitem',
                    				),
                            'options' => array(
                              'on' => esc_html__( 'Yes', 'divi-machine' ),
                              'off' => esc_html__( 'No', 'divi-machine' ),
                            ),
                    				'affects'         => array(
                    					'pretify_seperator',
                    				),
                            'default' => 'off',
                            'description' => esc_html__( 'Enable this if you want to pretify your text, improve readibility of long numbers. 10000000 → 10 000 000.', 'divi-machine' )
                          ),
                      'pretify_seperator' => array(
                      'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Pretify Separator', 'divi-machine' ),
                        'type'              => 'text',
                        'options_category' => 'configuration',
                				'computed_affects' => array(
                					'__getacfitem',
                				),
                				'depends_show_if'   => 'on',
                        'default'           => ', ',
                        'description'       => esc_html__( 'Set up your own separator for long numbers. 10 000, 10.000, 10-000 etc.', 'divi-machine' ),
                      ),
                      'prefix' => array(
                      'option_category' => 'configuration',
                      'toggle_slug'     => 'main_content',
                        'label'             => esc_html__( 'Prefix', 'divi-machine' ),
                        'type'              => 'text',
                        'computed_affects' => array(
                          '__getacfitem',
                        ),
                        'description'       => esc_html__( 'If you want text to appear directly before the ACF, add it here', 'divi-machine' ),
                      ),
                      'text_before' => array(
                      'option_category' => 'configuration',
                      'toggle_slug'     => 'main_content',
                        'label'             => esc_html__( 'Text Before', 'divi-machine' ),
                        'type'              => 'text',
                        'description'       => esc_html__( 'If you want text to appear before the choice field, add it here', 'divi-machine' ),
                      ),




                      'label_seperator' => array(
                      'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Label Seperator', 'divi-machine' ),
                        'type'              => 'text',
                        'option_category'   => 'configuration',
                				'depends_show_if'   => 'on',
                				'computed_affects' => array(
                					'__getacfitem',
                				),
                        'default'           => ': ',
                        'description'       => esc_html__( 'Add the label seperator here, something like : ', 'divi-machine' ),
                      ),
                      'use_icon' => array( // TODO: VB
                				'label'           => esc_html__( 'Use Icon', 'et_builder' ),
                				'type'            => 'yes_no_button',
                				'option_category' => 'basic_option',
                				'options'         => array(
                					'off' => esc_html__( 'No', 'et_builder' ),
                					'on'  => esc_html__( 'Yes', 'et_builder' ),
                				),
                				'toggle_slug'     => 'image',
                				'affects'         => array(
                					'font_icon',
                					'image_max_width',
                					'use_icon_font_size',
                					'use_circle',
                					'icon_color',
                					'image',
                					'alt',
                					'child_filter_hue_rotate',
                					'child_filter_saturate',
                					'child_filter_brightness',
                					'child_filter_contrast',
                					'child_filter_invert',
                					'child_filter_sepia',
                					'child_filter_opacity',
                					'child_filter_blur',
                					'child_mix_blend_mode',
                				),
                				'description' => esc_html__( 'Here you can choose whether icon set below should be used.', 'et_builder' ),
                				'default_on_front'=> 'off',
                			),
                			'font_icon' => array(
                				'label'               => esc_html__( 'Icon', 'et_builder' ),
                				'type'                => 'select_icon',
                				'option_category'     => 'basic_option',
                				'class'               => array( 'et-pb-font-icon' ),
                				'toggle_slug'         => 'image',
                				'computed_affects' => array(
                					'__geticon',
                				),
                				'description'         => esc_html__( 'Choose an icon to display with your ACF item.', 'et_builder' ),
                				'depends_show_if'     => 'on',
                				'mobile_options'      => true,
                				'hover'               => 'tabs',
                			),
                			'icon_color' => array(
                				'default'           => $et_accent_color,
                				'label'             => esc_html__( 'Icon Color', 'et_builder' ),
                				'type'              => 'color-alpha',
                				'description'       => esc_html__( 'Here you can define a custom color for your icon.', 'et_builder' ),
                				'depends_show_if'   => 'on',
                				'tab_slug'          => 'advanced',
                				'toggle_slug'       => 'icon_settings',
                				'hover'             => 'tabs',
                				'mobile_options'    => true,
                			),
                			'use_circle' => array(
                				'label'           => esc_html__( 'Circle Icon', 'et_builder' ),
                				'type'            => 'yes_no_button',
                				'option_category' => 'configuration',
                				'options'         => array(
                					'off' => esc_html__( 'No', 'et_builder' ),
                					'on'  => esc_html__( 'Yes', 'et_builder' ),
                				),
                				'affects'           => array(
                					'use_circle_border',
                					'circle_color',
                				),
                				'tab_slug'         => 'advanced',
                				'toggle_slug'      => 'icon_settings',
                				'description'      => esc_html__( 'Here you can choose whether icon set above should display within a circle.', 'et_builder' ),
                				'depends_show_if'  => 'on',
                				'default_on_front'=> 'off',
                			),
                			'circle_color' => array(
                				'default'         => $et_accent_color,
                				'label'           => esc_html__( 'Circle Color', 'et_builder' ),
                				'type'            => 'color-alpha',
                				'description'     => esc_html__( 'Here you can define a custom color for the icon circle.', 'et_builder' ),
                				'depends_show_if' => 'on',
                				'tab_slug'        => 'advanced',
                				'toggle_slug'     => 'icon_settings',
                				'hover'           => 'tabs',
                				'mobile_options'  => true,
                			),
                			'use_circle_border' => array(
                				'label'           => esc_html__( 'Show Circle Border', 'et_builder' ),
                				'type'            => 'yes_no_button',
                				'option_category' => 'layout',
                				'options'         => array(
                					'off' => esc_html__( 'No', 'et_builder' ),
                					'on'  => esc_html__( 'Yes', 'et_builder' ),
                				),
                				'affects'           => array(
                					'circle_border_color',
                				),
                				'description' => esc_html__( 'Here you can choose whether if the icon circle border should display.', 'et_builder' ),
                				'depends_show_if'   => 'on',
                				'tab_slug'          => 'advanced',
                				'toggle_slug'       => 'icon_settings',
                				'default_on_front'  => 'off',
                			),
                			'circle_border_color' => array(
                				'default'         => $et_accent_color,
                				'label'           => esc_html__( 'Circle Border Color', 'et_builder' ),
                				'type'            => 'color-alpha',
                				'description'     => esc_html__( 'Here you can define a custom color for the icon circle border.', 'et_builder' ),
                				'depends_show_if' => 'on',
                				'tab_slug'        => 'advanced',
                				'toggle_slug'     => 'icon_settings',
                				'hover'           => 'tabs',
                				'mobile_options'  => true,
                			),
                			'image' => array(
                				'label'              => esc_html__( 'Custom Image before/after', 'et_builder' ),
                				'type'               => 'upload',
                				'option_category'    => 'basic_option',
                				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),
                				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),
                				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),
                				'depends_show_if'    => 'off',
                				'description'        => esc_html__( 'Upload an image to display at the top of your ACF item.', 'et_builder' ),
                				'toggle_slug'        => 'image',
                				'dynamic_content'    => 'image',
                				'mobile_options'     => true,
                				'hover'              => 'tabs',
                			),
                			'alt' => array(
                				'label'           => esc_html__( 'Image Alt Text', 'et_builder' ),
                				'type'            => 'text',
                				'option_category' => 'basic_option',
                				'description'     => esc_html__( 'Define the HTML ALT text for your image here.', 'et_builder' ),
                				'depends_show_if' => 'off',
                				'tab_slug'        => 'custom_css',
                				'toggle_slug'     => 'attributes',
                				'dynamic_content' => 'text',
                			),
                      'icon_image_placement' => array(
                      'option_category' => 'basic_option',
                      'toggle_slug'     => 'image',
                        'label'             => esc_html__( 'Image / Icon Placement', 'divi-machine' ),
                        'type'              => 'select',
                        'options'           => array(
                          'top' => esc_html__( 'Top', 'divi-machine' ),
                          'right' => sprintf( esc_html__( 'Right', 'divi-machine' ) ),
                          'bottom' => sprintf( esc_html__( 'Bottom', 'divi-machine' ) ),
                          'left' => sprintf( esc_html__( 'Left', 'divi-machine' ) ),
                        ),
                        'default' => 'left',
                        'description'       => esc_html__( 'Choose where you want the icon or image to be.', 'divi-machine' ),
                      ),

                			'image_max_width' => array(
                				'label'           => esc_html__( 'Custom Image before/after max width', 'et_builder' ),
                				'description'     => esc_html__( 'Adjust the width of the image.', 'et_builder' ),
                				'type'            => 'range',
                        'option_category' => 'basic_option',
                        'toggle_slug'     => 'image',
                				'mobile_options'  => true,
                				'validate_unit'   => true,
                				'depends_show_if' => 'off',
                				'allowed_units'   => array( '%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw' ),
                				'default'         => '100%',
                				'default_unit'    => '%',
                				'default_on_front'=> '',
                				'allow_empty'     => true,
                				'range_settings'  => array(
                					'min'  => '0',
                					'max'  => '100',
                					'step' => '1',
                				),
                				'responsive'      => true,
                			),

                			// 'icon_image_padding_left' => array(
                			// 	'label'           => esc_html__( 'Image / Icon Padding Left', 'et_builder' ),
                			// 	'description'     => esc_html__( 'Adjust the passing on the left of the icon or the image.', 'et_builder' ),
                			// 	'type'            => 'range',
                      //   'option_category' => 'basic_option',
                      //   'toggle_slug'     => 'image',
                			// 	'validate_unit'   => true,
                			// 	'allowed_units'   => array( '%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw' ),
                			// 	'default'         => '0px',
                			// 	'default_unit'    => 'px',
                			// 	'default_on_front'=> '',
                			// 	'allow_empty'     => true,
                			// 	'range_settings'  => array(
                			// 		'min'  => '0',
                			// 		'max'  => '100',
                			// 		'step' => '1',
                			// 	),
                			// ),
                      //
                			// 'icon_image_padding_right' => array(
                			// 	'label'           => esc_html__( 'Image / Icon Padding Right', 'et_builder' ),
                			// 	'description'     => esc_html__( 'Adjust the passing on the right of the icon or the image.', 'et_builder' ),
                			// 	'type'            => 'range',
                      //   'option_category' => 'basic_option',
                      //   'toggle_slug'     => 'image',
                			// 	'validate_unit'   => true,
                			// 	'allowed_units'   => array( '%', 'em', 'rem', 'px', 'cm', 'mm', 'in', 'pt', 'pc', 'ex', 'vh', 'vw' ),
                			// 	'default'         => '10px',
                			// 	'default_unit'    => 'px',
                			// 	'default_on_front'=> '',
                			// 	'allow_empty'     => true,
                			// 	'range_settings'  => array(
                			// 		'min'  => '0',
                			// 		'max'  => '100',
                			// 		'step' => '1',
                			// 	),
                			// ),

                      // Specific field

                      'return_format' => array(
                      'option_category' => 'basic_option',
                      'toggle_slug'     => 'specific',
                        'label'             => esc_html__( 'Image/File/Link Return Format', 'divi-machine' ),
                        'type'              => 'select',
                        'options'           => array(
                          'array' => esc_html__( 'Array', 'divi-machine' ),
                          'url' => sprintf( esc_html__( 'URL', 'divi-machine' ) ),
                          'id' => sprintf( esc_html__( 'ID', 'divi-machine' ) ),
                          'value' => sprintf( esc_html__( 'Choice Value', 'divi-machine' ) ),
                          'label' => sprintf( esc_html__( 'Choice Label', 'divi-machine' ) ),
                          'both' => sprintf( esc_html__( 'Choice Both', 'divi-machine' ) ),
                        ),
                        'default' => 'array',
                				'computed_affects' => array(
                					'__getacfitem',
                				),
                        'description'       => esc_html__( 'Choose how you have defined the return format in ACF settings.', 'divi-machine' ),
                      ),

                          'link_button' => array(
                          'option_category' => 'basic_option',
                          'toggle_slug'     => 'specific',
                            'label' => esc_html__( 'Make File/Link Button?', 'divi-machine' ),
                            'type' => 'yes_no_button',
                            'options_category' => 'configuration',
                            'options' => array(
                              'on' => esc_html__( 'Yes', 'divi-machine' ),
                              'off' => esc_html__( 'No', 'divi-machine' ),
                            ),
                            'default' => 'off',
                            'description' => esc_html__( 'Enable this if you want to make the file or link a button.', 'divi-machine' )
                          ),
                          'url_link_icon' => array(
                          'option_category' => 'basic_option',
                          'toggle_slug'     => 'specific',
                            'label' => esc_html__( 'URL field - remove website link name', 'divi-machine' ),
                            'type' => 'yes_no_button',
                            'options_category' => 'configuration',
                            'options' => array(
                              'on' => esc_html__( 'Yes', 'divi-machine' ),
                              'off' => esc_html__( 'No', 'divi-machine' ),
                            ),
                            'default' => 'off',
                            'description' => esc_html__( 'Enable this if you want to remove the url name and have the icon/image link.', 'divi-machine' )
                          ),
            'image_size' => array(
            'option_category' => 'basic_option',
            'toggle_slug'     => 'specific',
                'label' => __('Image Size', 'et_builder'),
                'type' => 'select',
                'options' => $options,
                'default' => 'full',
                'description' => __('Choose the size of the image you want to display, if you are using an image field and returning the ID or array.', 'et_builder'),
            ),
            'true_false_text_true' => array(
            'option_category' => 'basic_option',
            'toggle_slug'     => 'specific',
              'label'             => esc_html__( 'True/False Text - True', 'divi-machine' ),
              'type'              => 'text',
              'default'           => 'True',
              'description'       => esc_html__( 'Add the text you want to appear when they select true in the True / False field', 'divi-machine' ),
            ),
            'true_false_text_false' => array(
            'option_category' => 'basic_option',
            'toggle_slug'     => 'specific',
              'label'             => esc_html__( 'True/False Text - False', 'divi-machine' ),
              'type'              => 'text',
              'default'           => 'False',
              'description'       => esc_html__( 'Add the text you want to appear when they select false in the True / False field', 'divi-machine' ),
            ),

            'button_alignment' => array(
              'label'            => esc_html__( 'ACF Item Alignment', 'et_builder' ),
              'description'      => esc_html__( 'Align your ACF item and icon/image.', 'et_builder' ),
              'type'             => 'text_align',
              'option_category'  => 'configuration',
              'options'          => et_builder_get_text_orientation_options( array( 'justified' ) ),
              'tab_slug'         => 'advanced',
              'toggle_slug'      => 'alignment',
            ),
            '__getacfitem' => array(
            'type' => 'computed',
            'computed_callback' => array( 'de_mach_acf_item_code', 'get_acf_item' ),
            'computed_depends_on' => array(
            'acf_name',
            'pretify_text',
            'pretify_seperator',
            'prefix',
            'label_seperator',
            'custom_label',
            'return_format',
            ),
            ),
            '__geticon' => array(
            'type' => 'computed',
            'computed_callback' => array( 'de_mach_acf_item_code', 'get_icon_code' ),
            'computed_depends_on' => array(
            'font_icon'
            ),
            ),




                      );

                      return $fields;
                  }

                  public static function get_icon_code ( $args = array(), $conditional_tags = array(), $current_page = array() ){
                    if (!is_admin()) {
                      return;
                    }
                    ob_start();
                    $font_icon = $args['font_icon'];
                    $font_icon_rendered = preg_replace( '/(&amp;#x)|;/', '', et_pb_process_font_icon( $font_icon ) );

                    echo $font_icon_rendered;

                    $data = ob_get_clean();

                  return $data;

                  }

                  public static function get_acf_item ( $args = array(), $conditional_tags = array(), $current_page = array() ){
                    if (!is_admin()) {
                      return;
                    }

                      ob_start();

      $acf_name = $args['acf_name'];
      $pretify_text = $args['pretify_text'];
      $pretify_seperator = $args['pretify_seperator'];
      $prefix = $args['prefix'];
      $label_seperator = $args['label_seperator'];
      $image = $args['image'];
      $custom_label = $args['custom_label'];
      $return_format = $args['return_format'];



      $post_slug = DEDMACH_INIT::get_vb_post_type();

    $get_cpt_args = array(
      'post_type' => $post_slug,
      'post_status' => 'publish',
      'posts_per_page' => '1',
      'orderby' => 'ID',
      'order' => 'ASC',
  );

  query_posts( $get_cpt_args );

  $first = true;

  if ( have_posts() ) {
    while ( have_posts() ) {
      the_post();
      // setup_postdata( $post );

    if ( $first )  {

//////////////////////////////////////////////////

$get_id = get_the_ID();
$get_title = get_the_title();
if( isset($acf_name) && $acf_name !== 'none') {

// $acf_value = get_field($acf_name, $get_id);
$acf_get = get_field_object($acf_name);
$acf_type = $acf_get['type'];

// TODO: Do VB for acf items



?>

<?php

$basic_acf_types = "text, textarea, number, range, email, password, wysiwyg, oembed, date_picker, date_time_picker, time_picker";
$basic_acf_types_explode = explode(', ',$basic_acf_types);

$choice_acf_choice_types = "select, checkbox, radio, button_group, true_false";
$choice_acf_choice_types_explode = explode(', ',$choice_acf_choice_types);


if ($custom_label == "") {
$show_label_dis =  $acf_get['label'] . $label_seperator;
} else {
$show_label_dis =  $custom_label . $label_seperator;
}

$show_label_dis = '<span class="dmach-acf-label">' . $show_label_dis . '</span>';



////////////////////////////////////////////////////
// basic fields
////////////////////////////////////////////////////
if (in_array($acf_type, $basic_acf_types_explode)) {

if ($pretify_text == "on" && ( $acf_type == 'number' || $acf_type == 'range' )) {
  $item_value_before = number_format( $acf_get['value'] , 0 , '.' , ',' );
  $item_value = str_replace(',', $pretify_seperator, $item_value_before);
} else {
  $item_value = $acf_get['value'];
}

$label_seperator = '<span class="dmach-seperator">' . esc_html($label_seperator) . '</span>';

?>

<p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo $prefix; ?><?php echo $item_value; ?></p>

<?php

}
////////////////////////////////////////////////////
// image fields
////////////////////////////////////////////////////

else if ($acf_type == "image") {

  if ($return_format == "array") {

    $thumb = $acf_get['value']['sizes'][ $image_size ];
    ?>
  <?php echo $show_label_dis ?>  <img class="dmach-acf-value" src="<?php echo esc_url($thumb); ?>" alt="<?php echo esc_attr($acf_get['value']['alt']); ?>" />
  <?php } else if ($return_format == "id") {
  echo wp_get_attachment_image( $acf_get['value'], $image_size );
  } else if ($return_format == "id") {
  echo wp_get_attachment_image( $acf_get['value'], $image_size );
  } else { ?>
  <?php echo $show_label_dis ?>  <img class="dmach-acf-value" src="<?php echo $acf_get['value']; ?>" />
  <?php
}

}
////////////////////////////////////////////////////
// file fields
////////////////////////////////////////////////////

 else if ($acf_type == "file") {
   if ($return_format == "array") {
     $title = $acf_get['value']['title'];
     $icon = $acf_get['value']['icon'];
     if( $acf_get['value']['type'] == 'image' ) {
       $icon =  $acf_get['value']['sizes']['thumbnail'];
     }
     ?>
     <?php echo $show_label_dis ?>
     <a class="dmach-acf-value et_pb_button" href="<?php echo $acf_get['value']['url']; ?>"><span><?php echo esc_html($title); ?></span></a>
     <a class="dmach-acf-value no-button" href="<?php echo $acf_get['value']['url']; ?>"><span><?php echo esc_html($title); ?></span></a>
                 <?php
     } else if ($return_format == "id") {
       $url = wp_get_attachment_url( $acf_get['value'] ); ?>
       <?php echo $show_label_dis ?>
       <a class="dmach-acf-value et_pb_button" href="<?php echo esc_html($url); ?>" >Download File</a>
       <a class="dmach-acf-value no-button" href="<?php echo esc_html($url); ?>" >Download File</a> <?php
     } else { ?>
       <?php echo $show_label_dis ?>
       <a class="dmach-acf-value et_pb_button" href="<?php echo $acf_get['value']; ?>" >Download File</a>
       <a class="dmach-acf-value no-button" href="<?php echo $acf_get['value']; ?>" >Download File</a> <?php
     }
 }
 ////////////////////////////////////////////////////
 // Choice fields
 ////////////////////////////////////////////////////

 else if (in_array($acf_type, $choice_acf_choice_types_explode)) {

   if ($acf_get['multiple'] == "1") {
     $getselected_name = $acf_get['choices'][$acf_get['value']];
   ?>
   <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo implode( ', ', $getselected_name ); ?></p>
   <?php
   } else {
   if ($acf_type == "checkbox") {
     $getselected_name = $acf_get['value'];
   ?>
   <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo implode( ', ', $getselected_name ); ?></p>
   <?php
   } else if ($acf_type == "true_false") {
   ?>
   <p class="dmach-acf-value">
   <?php echo $show_label_dis ?>
   <?php
   if ($acf_get['value'] == "1") {
   echo $true_false_text_true;
   } else {
   echo $true_false_text_false;
   }
   ?></p>
   <?php
   } else {
     $getselected_name = $acf_get['value'];
   ?>
   <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo $getselected_name ?></p>
   <?php
   }
   }

 }
 ////////////////////////////////////////////////////
 //  link fields
 ////////////////////////////////////////////////////

  else if ($acf_type == "link") {

    if ($return_format == "array") {
      $title = $acf_get['value']['title'];
      $target = $acf_get['value']['target'];
      $url = $acf_get['value']['url'];
      ?>
      <?php echo $show_label_dis ?>
      <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $url; ?>" target="<?php echo esc_html($target) ?>">
        <span><?php echo esc_html($title); ?></span>
      </a>
      <?php
      } else { ?>
        <?php echo $show_label_dis ?>
      <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $acf_get['value']; ?>" target="<?php echo esc_html($target) ?>" ><?php echo $acf_get['value']; ?></a><?php
                }

  }
  ////////////////////////////////////////////////////
  //  URL fields
  ////////////////////////////////////////////////////

   else if ($acf_type == "url") {
    echo $show_label_dis
     ?>
     <a class="dmach-acf-value et_pb_button" href="<?php echo $acf_get['value']; ?>" target="_blank" ><?php echo $acf_get['value']; ?></a>
     <a class="dmach-acf-value no-button" href="<?php echo $acf_get['value']; ?>" target="_blank" ></a>
     <?php
   }

} else {
echo 'Please select an ACF field you have created';
}

//////////////////////////////////////////////////
  $first = false;
    } else {

    }

}
}

                    $data = ob_get_clean();

                  return $data;

                  }


                  public function get_button_alignment( $device = 'desktop' ) {
              $suffix           = 'desktop' !== $device ? "_{$device}" : '';
              $text_orientation = isset( $this->props["button_alignment{$suffix}"] ) ? $this->props["button_alignment{$suffix}"] : '';

              return et_pb_get_alignment( $text_orientation );
            }



                  function render( $attrs, $content = null, $render_slug ) {

                    // if (is_admin()) {
                    //     return;
                    // }

                    $acf_name                        = $this->props['acf_name'];
                    // $acf_type                        = $this->props['acf_type'];
                		$use_icon                        = $this->props['use_icon'];
                		$font_icon                       = $this->props['font_icon'];

                		$icon_color                      = $this->props['icon_color'];
                		$icon_color_hover                = $this->get_hover_value( 'icon_color' );
                		$icon_color_values               = et_pb_responsive_options()->get_property_values( $this->props, 'icon_color' );
                		$icon_color_tablet               = isset( $icon_color_values['tablet'] ) ? $icon_color_values['tablet'] : '';
                		$icon_color_phone                = isset( $icon_color_values['phone'] ) ? $icon_color_values['phone'] : '';

                		$circle_color                    = $this->props['circle_color'];
                		$circle_color_hover              = $this->get_hover_value( 'circle_color' );
                		$circle_color_values             = et_pb_responsive_options()->get_property_values( $this->props, 'circle_color' );
                		$circle_color_tablet             = isset( $circle_color_values['tablet'] ) ? $circle_color_values['tablet'] : '';
                		$circle_color_phone              = isset( $circle_color_values['phone'] ) ? $circle_color_values['phone'] : '';

                    $show_label                      = $this->props['show_label'];
                    $custom_label                    = $this->props['custom_label'];
                    $label_seperator                 = $this->props['label_seperator'];
                    $image                           = $this->props['image'];
                    $alt                             = $this->props['alt'];
                    $icon_image_placement            = $this->props['icon_image_placement'];
                    $use_circle                      = $this->props['use_circle'];
                		$use_circle_border               = $this->props['use_circle_border'];

                    $circle_border_color             = $this->props['circle_border_color'];
                		$circle_border_color_hover       = $this->get_hover_value( 'circle_border_color' );
                		$circle_border_color_values      = et_pb_responsive_options()->get_property_values( $this->props, 'circle_border_color' );
                		$circle_border_color_tablet      = isset( $circle_border_color_values['tablet'] ) ? $circle_border_color_values['tablet'] : '';
                		$circle_border_color_phone       = isset( $circle_border_color_values['phone'] ) ? $circle_border_color_values['phone'] : '';

                    $icon_placement                  = $this->props['icon_image_placement'];
                		$icon_placement_values           = et_pb_responsive_options()->get_property_values( $this->props, 'icon_placement' );
                		$icon_placement_tablet           = isset( $icon_placement_values['tablet'] ) ? $icon_placement_values['tablet'] : '';
                		$icon_placement_phone            = isset( $icon_placement_values['phone'] ) ? $icon_placement_values['phone'] : '';
                		$is_icon_placement_responsive    = et_pb_responsive_options()->is_responsive_enabled( $this->props, 'icon_placement' );
                		$is_icon_placement_top           = ! $is_icon_placement_responsive ? 'top' === $icon_placement : in_array( 'top', $icon_placement_values );

                    $return_format                   = $this->props['return_format'];
                    // $choice_return_format            = $this->props['choice_return_format'];
                    $image_size                      = $this->props['image_size'];
                    $prefix                      = $this->props['prefix'];

                    $text_before                     = $this->props['text_before'];
                    $true_false_text_true            = $this->props['true_false_text_true'];
                    $true_false_text_false           = $this->props['true_false_text_false'];

                		$image_max_width                 = $this->props['image_max_width'];
                		$image_max_width_tablet          = $this->props['image_max_width_tablet'];
                		$image_max_width_phone           = $this->props['image_max_width_phone'];
                		$image_max_width_last_edited     = $this->props['image_max_width_last_edited'];


                		$pretify_text     = $this->props['pretify_text'];
                		$pretify_seperator     = $this->props['pretify_seperator'];

                    $link_button    = $this->props['link_button'];
                    $url_link_icon    = $this->props['url_link_icon'];


                                        $button_alignment                = $this->get_button_alignment();
                                        $button_alignments = sprintf( 'et_pb_de_mach_alignment_%1$s', esc_attr( $button_alignment ) );

                                        $this->add_classname( $button_alignments );

                    $font_icon_rendered = DEDMACH_INIT::et_icon_css_content( esc_attr($font_icon) );

                		$is_image_svg   = isset( $image_pathinfo['extension'] ) ? 'svg' === $image_pathinfo['extension'] : false;

                    $icon_selector = '%%order_class%% .dmach-icon';

                    if ( '' !== $image_max_width_tablet || '' !== $image_max_width_phone || '' !== $image_max_width || $is_image_svg ) {
                			$is_size_px = false;

                			// If size is given in px, we want to override parent width
                			if (
                				false !== strpos( $image_max_width, 'px' ) ||
                				false !== strpos( $image_max_width_tablet, 'px' ) ||
                				false !== strpos( $image_max_width_phone, 'px' )
                			) {
                				$is_size_px = true;
                			}
                			// SVG image overwrite. SVG image needs its value to be explicit
                			if ( '' === $image_max_width && $is_image_svg ) {
                				$image_max_width = '100%';
                			}

                			// Image max width selector.
                			$image_max_width_selectors       = array();
                			$image_max_width_reset_selectors = array();
                			$image_max_width_reset_values    = array();

                			$image_max_width_selector = $is_image_svg ? '%%order_class%% .dmach-icon-image-content' : '%%order_class%% .dmach-icon-image-content';


                      foreach ( array( 'tablet', 'phone' ) as $device ) {
                        $device_icon_placement = 'tablet' === $device ? $icon_placement_tablet : $icon_placement_phone;
                        if ( empty( $device_icon_placement ) ) {
                          continue;
                        }

                        $image_max_width_selectors[ $device ] = 'top' === $device_icon_placement && $is_image_svg ? '%%order_class%% .dmach-icon-image-content' : '%%order_class%% .dmach-icon-image-content';

                        $prev_icon_placement = 'tablet' === $device ? $icon_placement : $icon_placement_tablet;
                        if ( empty( $prev_icon_placement ) || $prev_icon_placement === $device_icon_placement || ! $is_image_svg ) {
                          continue;
                        }

                        // Image/icon placement setting is related to image width setting. In some cases,
                        // user uses different image/icon placement settings for each devices. We need to
                        // reset previous device image width styles to make it works with current style.
                        $image_max_width_reset_selectors[ $device ] = '%%order_class%% .dmach-icon-image-content';
                        $image_max_width_reset_values[ $device ]    = array( 'width' => '32px' );

                        if ( 'top' === $device_icon_placement ) {
                          $image_max_width_reset_selectors[ $device ] = '%%order_class%% .dmach-icon-image-content';
                          $image_max_width_reset_values[ $device ]    = array( 'width' => 'auto' );
                        }
                      }

                      // Add image max width desktop selector if user sets different image/icon placement setting.
                      if ( ! empty( $image_max_width_selectors ) ) {
                        $image_max_width_selectors['desktop'] = $image_max_width_selector;
                      }

                      $image_max_width_property = ( $is_image_svg || $is_size_px ) ? 'width' : 'max-width';

                      $image_max_width_responsive_active = et_pb_get_responsive_status( $image_max_width_last_edited );

                      $image_max_width_values = array(
                        'desktop' => $image_max_width,
                        'tablet'  => $image_max_width_responsive_active ? $image_max_width_tablet : '',
                        'phone'   => $image_max_width_responsive_active ? $image_max_width_phone : '',
                      );

                      $main_image_max_width_selector = $image_max_width_selector;

                      // Overwrite image max width if there are image max width selectors for different devices.
                      if ( ! empty( $image_max_width_selectors ) ) {
                        $main_image_max_width_selector = $image_max_width_selectors;

                        if ( ! empty( $image_max_width_selectors['tablet'] ) && empty( $image_max_width_values['tablet'] ) ) {
                          $image_max_width_values['tablet'] = $image_max_width_responsive_active ? esc_attr( et_pb_responsive_options()->get_any_value( $this->props, 'image_max_width_tablet', '100%', true ) ) : esc_attr( $image_max_width );
                        }

                        if ( ! empty( $image_max_width_selectors['phone'] ) && empty( $image_max_width_values['phone'] ) ) {
                          $image_max_width_values['phone'] = $image_max_width_responsive_active ? esc_attr( et_pb_responsive_options()->get_any_value( $this->props, 'image_max_width_phone', '100%', true ) ) : esc_attr( $image_max_width );
                        }
                      }


                      et_pb_responsive_options()->generate_responsive_css( $image_max_width_values, $main_image_max_width_selector, $image_max_width_property, $render_slug );

                			// Reset custom image max width styles.
                			if ( ! empty( $image_max_width_selectors ) && ! empty( $image_max_width_reset_selectors ) ) {
                				et_pb_responsive_options()->generate_responsive_css( $image_max_width_reset_values, $image_max_width_reset_selectors, $image_max_width_property, $render_slug, '', 'input' );
                			}
                		}


                    if ( 'off' === $use_icon ) {
                		} else {
                			$icon_style        = sprintf( 'color: %1$s;', esc_attr( $icon_color ) );
                			$icon_tablet_style = '' !== $icon_color_tablet ? sprintf( 'color: %1$s;', esc_attr( $icon_color_tablet ) ) : '';
                			$icon_phone_style  = '' !== $icon_color_phone ? sprintf( 'color: %1$s;', esc_attr( $icon_color_phone ) ) : '';
                			$icon_style_hover  = '';

                			if ( et_builder_is_hover_enabled( 'icon_color', $this->props ) ) {
                				$icon_style_hover = sprintf( 'color: %1$s;', esc_attr( $icon_color_hover ) );
                			}

                			if ( 'on' === $use_circle ) {
                				$icon_style .= sprintf( ' background-color: %1$s;', esc_attr( $circle_color ) );
                				$icon_tablet_style .= '' !== $circle_color_tablet ? sprintf( ' background-color: %1$s;', esc_attr( $circle_color_tablet ) ) : '';
                				$icon_phone_style  .= '' !== $circle_color_phone ? sprintf( ' background-color: %1$s;', esc_attr( $circle_color_phone ) ) : '';

                				if ( et_builder_is_hover_enabled( 'circle_color', $this->props ) ) {
                					$icon_style_hover .= sprintf( ' background-color: %1$s;', esc_attr( $circle_color_hover ) );
                				}

                				if ( 'on' === $use_circle_border ) {
                					$icon_style .= sprintf( ' border-color: %1$s;', esc_attr( $circle_border_color ) );
                					$icon_tablet_style .= '' !== $circle_border_color_tablet ? sprintf( ' border-color: %1$s;', esc_attr( $circle_border_color_tablet ) ) : '';
                					$icon_phone_style  .= '' !== $circle_border_color_phone ? sprintf( ' border-color: %1$s;', esc_attr( $circle_border_color_phone ) ) : '';

                					if ( et_builder_is_hover_enabled( 'circle_border_color', $this->props ) ) {
                						$icon_style_hover .= sprintf( ' border-color: %1$s;', esc_attr( $circle_border_color_hover ) );
                					}
                				}
                			}

                      ET_Builder_Element::set_style( $render_slug, array(
                        'selector'    => '%%order_class%% .dmach-icon:before',
                        'declaration' => sprintf(
                          'content: "%1$s";
                          color: %2$s',
                          esc_html( $font_icon_rendered ),
                          $icon_color
                        ),
                      ) );

                      ET_Builder_Element::set_style( $render_slug, array(
                        'selector'    => '%%order_class%% .dmach-icon:hover:before',
                        'declaration' => sprintf(
                          'color: %1$s',
                          $icon_color_hover
                        ),
                      ) );

                			ET_Builder_Element::set_style( $render_slug, array(
                				'selector'    => $icon_selector,
                				'declaration' => $icon_style,
                			) );

                			ET_Builder_Element::set_style( $render_slug, array(
                				'selector'    => $icon_selector,
                				'declaration' => $icon_tablet_style,
                				'media_query' => ET_Builder_Element::get_media_query( 'max_width_980' ),
                			) );

                			ET_Builder_Element::set_style( $render_slug, array(
                				'selector'    => $icon_selector,
                				'declaration' => $icon_phone_style,
                				'media_query' => ET_Builder_Element::get_media_query( 'max_width_767' ),
                			) );


                    			if ( '' !== $icon_style_hover ) {
                				ET_Builder_Element::set_style( $render_slug, array(
                					'selector'    => $this->add_hover_to_order_class( $icon_selector ),
                					'declaration' => $icon_style_hover,
                				) );
                			}

                			$image_classes[] = 'et-pb-icon';

                			if ( 'on' === $use_circle ) {
                				$image_classes[] = 'et-pb-icon-circle';
                			}

                			if ( 'on' === $use_circle && 'on' === $use_circle_border ) {
                				$image_classes[] = 'et-pb-icon-circle-border';
                			}


                		}

                  //////////////////////////////////////////////////////////////////////

                    ob_start();


                    if( get_field($acf_name) ) {
                      $acf_get = get_field_object($acf_name);
                    } else if (get_sub_field($acf_name)) {
                      $acf_get = get_sub_field_object($acf_name);
                    }else {

                    }


                    $acf_type = $acf_get['type'];



                    $label_seperator = '<span class="dmach-seperator">' . esc_html($label_seperator) . '</span>';

                    if ($show_label == "on") {
                        if ($custom_label == "") {
                      $show_label_dis =  $acf_get['label'] . $label_seperator;
                    } else {
                      $show_label_dis =  $custom_label . $label_seperator;
                    }
                      $show_label_dis = '<span class="dmach-acf-label">' . $show_label_dis . '</span>';
                    } else {
                      $show_label_dis = "";
                    }

                    if ($use_icon == "on") {
                    $icon_image_dis = '<div class="dmach-icon-image-content"><span class="dmach-icon"></span></div>';
                    } else {
                      if ($image == "") {

                      } else {
                    $icon_image_dis = '<div class="dmach-icon-image-content"><img src="'.$image.'"></div>';
                            }
                    }

                    if ($icon_image_placement == "top" || $icon_image_placement == "left") {
                      $icon_image_placement_left = $icon_image_dis;
                      $icon_image_placement_right = "";
                    } else {
                      $icon_image_placement_left = "";
                      $icon_image_placement_right = $icon_image_dis;
                    }


                      $this->add_classname( 'dmach-image-icon-placement-' . $icon_image_placement . '' );

                    $basic_acf_types = "text, textarea, number, range, email, password, wysiwyg, oembed, date_picker, date_time_picker, time_picker";
                    $basic_acf_types_explode = explode(', ',$basic_acf_types);

                    $choice_acf_choice_types = "select, checkbox, radio, button_group, true_false";
                    $choice_acf_choice_types_explode = explode(', ',$choice_acf_choice_types);



                    ////////////////////////////////////////////////////
                    // basic fields
                    ////////////////////////////////////////////////////
                    if (in_array($acf_type, $basic_acf_types_explode)) {



                      if ($pretify_text == "on" && ( $acf_type == 'number' || $acf_type == 'range' )) {

                        $item_value_before = number_format( $acf_get['value'] , 0 , '.' , ',' );
                        $item_value = str_replace(',', $pretify_seperator, $item_value_before);


                      } else {
                        $item_value = $acf_get['value'];
                      }

                      ?>
                      <div class="dmach-acf-item-containter">
                      <?php echo $icon_image_placement_left; ?>
                      <div class="dmach-acf-item-content">
                      <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                      <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo $prefix; ?><?php echo $item_value; ?></p>
                      </div>
                      <?php echo $icon_image_placement_right; ?>
                    </div>
                    <?php
                    }

                    ////////////////////////////////////////////////////
                    // image fields
                    ////////////////////////////////////////////////////

                    else if ($acf_type == "image") {



                      if( !empty( $acf_get['value'] ) ):
                         ?>
                      <div class="dmach-acf-item-containter">
                      <?php echo $icon_image_placement_left; ?>
                      <div class="dmach-acf-item-content">
                      <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                      <?php if ($return_format == "array") {

                        $thumb = $acf_get['value']['sizes'][ $image_size ];
                        ?>
                    <?php echo $show_label_dis ?>  <img class="dmach-acf-value" src="<?php echo esc_url($thumb); ?>" alt="<?php echo esc_attr($acf_get['value']['alt']); ?>" />
                    <?php } else if ($return_format == "id") {
                      echo wp_get_attachment_image( $acf_get['value'], $image_size );
                    } else if ($return_format == "id") {
                      echo wp_get_attachment_image( $acf_get['value'], $image_size );
                    } else { ?>
                    <?php echo $show_label_dis ?>  <img class="dmach-acf-value" src="<?php echo $acf_get['value']; ?>" />
                    <?php } ?>
                  </div>
                  <?php echo $icon_image_placement_right; ?>
                </div>
                      <?php endif;
                      }

                    ////////////////////////////////////////////////////
                    // file fields
                    ////////////////////////////////////////////////////

                     else if ($acf_type == "file") {


                                          if ($link_button == "on") {
                                            $link_button_css = "et_pb_button";
                                          } else {
                                            $link_button_css = "";
                                          }

                      if( $acf_get['value'] ): ?>
                      <div class="dmach-acf-item-containter">
                      <?php echo $icon_image_placement_left; ?>
                      <div class="dmach-acf-item-content">
                      <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                      <?php if ($return_format == "array") {
                        $title = $acf_get['value']['title'];
                        $icon = $acf_get['value']['icon'];
                        if( $acf_get['value']['type'] == 'image' ) {
                          $icon =  $acf_get['value']['sizes']['thumbnail'];
                        }
                        ?>
                        <?php echo $show_label_dis ?>
                        <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $acf_get['value']['url']; ?>">
                          <span><?php echo esc_html($title); ?></span>
                        </a>
                        <?php
                        } else if ($return_format == "id") {
                          $url = wp_get_attachment_url( $acf_get['value'] ); ?>
                          <?php echo $show_label_dis ?>
                          <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo esc_html($url); ?>" >Download File</a> <?php
                        } else { ?>
                          <?php echo $show_label_dis ?>
                          <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $acf_get['value']; ?>" >Download File</a> <?php
                        }
                        ?>
                      </div>
                      <?php echo $icon_image_placement_right; ?>
                    </div>
                    <?php
                     endif;

                    }
                    ////////////////////////////////////////////////////
                    // Choice fields
                    ////////////////////////////////////////////////////

                    else if (in_array($acf_type, $choice_acf_choice_types_explode)) {
                     if( $acf_get['value'] ):


?>
<div class="dmach-acf-item-containter">
<?php echo $icon_image_placement_left; ?>
<div class="dmach-acf-item-content">
  <?php
                    if ($acf_get['multiple'] == "1") {
                      $getselected_name = $acf_get['choices'][$acf_get['value']];
                    ?>
                    <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                    <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo implode( ', ', $getselected_name ); ?></p>
                    <?php
                    } else {
                    if ($acf_type == "checkbox") {
                      $getselected_name = $acf_get['value'];
                    ?>
                    <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                    <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo implode( ', ', $getselected_name ); ?></p>
                    <?php
                  } else if ($acf_type == "true_false") {
                  ?>
                  <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                  <p class="dmach-acf-value">
                    <?php echo $show_label_dis ?>
                    <?php
                  if ($acf_get['value'] == "1") {
                    echo $true_false_text_true;
                  } else {
                    echo $true_false_text_false;
                  }
                   ?></p>
                  <?php


                } else {
                  $getselected_name = $acf_get['value'];
                    ?>
                    <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                    <p class="dmach-acf-value"><?php echo $show_label_dis ?><?php echo $getselected_name ?></p>
                    <?php
                  }
                    }
?>
</div>
<?php echo $icon_image_placement_right; ?>
</div>
<?php
                 endif;

                  }

                ////////////////////////////////////////////////////
                //  link fields
                ////////////////////////////////////////////////////

                 else if ($acf_type == "link") {

                   if ($link_button == "on") {
                     $link_button_css = "et_pb_button";
                   } else {
                     $link_button_css = "";
                   }

                  if( $acf_get['value'] ): ?>
                  <div class="dmach-acf-item-containter">
                  <?php echo $icon_image_placement_left; ?>
                  <div class="dmach-acf-item-content">
                  <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>

                  <?php if ($return_format == "array") {
                    $title = $acf_get['value']['title'];
                    $target = $acf_get['value']['target'];
                    $url = $acf_get['value']['url'];
                    ?>
                    <?php echo $show_label_dis ?>
                    <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $url; ?>" target="<?php echo esc_html($target) ?>">
                      <span><?php echo esc_html($title); ?></span>
                    </a>
                    <?php
                    } else { ?>
                      <?php echo $show_label_dis ?>
                    <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $acf_get['value']; ?>" target="<?php echo esc_html($target) ?>" ><?php echo $acf_get['value']; ?></a><?php
                              }
                    ?>
                  </div>
                  <?php echo $icon_image_placement_right; ?>
                </div>
                <?php
                 endif;

                }

              ////////////////////////////////////////////////////
              //  URL fields
              ////////////////////////////////////////////////////

               else if ($acf_type == "url") {

                 if ($link_button == "on") {
                   $link_button_css = "et_pb_button";
                 } else {
                   $link_button_css = "";
                 }

                if( $acf_get['value'] ): ?>
                <div class="dmach-acf-item-containter">

                  <?php if ($url_link_icon == 'on') {
                  ?> <a href="<?php echo $acf_get['value']; ?>" target="_blank"> <?php
                  }
                  ?>
                <?php echo $icon_image_placement_left; ?>
                <div class="dmach-acf-item-content">
                <?php if ($text_before != ""){ ?><p class="dmach-acf-before"><?php echo $text_before ?></p><?php } ?>
                    <?php echo $show_label_dis ?>
                    <?php if ($url_link_icon == 'off') {
                    ?>
                    <a class="dmach-acf-value <?php echo $link_button_css ?>" href="<?php echo $acf_get['value']; ?>" target="_blank" ><?php echo $acf_get['value']; ?></a>
                    <?php
                    }
                    ?>
                </div>
                <?php echo $icon_image_placement_right; ?>
                <?php if ($url_link_icon == 'on') {
                ?> </a> <?php
                }
                ?>
              </div>
              <?php
               endif;

              }



                    $data = ob_get_clean();

                   //////////////////////////////////////////////////////////////////////
                    // $this->props['content'] = $data;

                  return $data;



              }

            }

            new de_mach_acf_item_code;

?>
