<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class de_mach_carousel_code extends ET_Builder_Module {

public $vb_support = 'on';

protected $module_credits = array(
  'module_uri' => DE_DMACH_PRODUCT_URL,
  'author'     => DE_DMACH_AUTHOR,
  'author_uri' => DE_DMACH_URL,
);

                function init() {
                    $this->name       = esc_html__( '.Post Carousel - Divi Machine', 'divi-machine' );
                    $this->slug = 'et_pb_de_mach_carousel';


                    $this->fields_defaults = array(
                    // 'loop_layout'         => array( 'on' ),
                    );

          $this->settings_modal_toggles = array(
      			'general' => array(
      				'toggles' => array(
      					'main_content' => esc_html__( 'Main Options', 'divi-machine' ),
        					'loop_options' => esc_html__( 'Loop Options', 'divi-machine' ),
        					'element_options' => esc_html__( 'Element Options', 'divi-machine' ),
        					'grid_options' => esc_html__( 'Grid Options', 'divi-machine' ),
        					'extra_options' => esc_html__( 'Extra Options', 'divi-machine' ),
        					'carousel_settings' => esc_html__( 'Carousel Settings', 'divi-machine' ),
      				),
      			),
      			'advanced' => array(
      				'toggles' => array(
      					'text' => esc_html__( 'Text', 'divi-machine' ),
					      'overlay' => esc_html__( 'Overlay', 'divi-machine' ),
      				),
      			),

      		);


                      $this->main_css_element = '%%order_class%%';


                      $this->advanced_fields = array(
                  			'fonts' => array(
                  				'title' => array(
                  					'label'    => esc_html__( 'Default Layout - Title', 'divi-machine' ),
                  					'css'      => array(
                  						'main' => "%%order_class%% ul.products li.product .woocommerce-loop-product__title",
                  						'important' => 'plugin_only',
                  					),
                  					'font_size' => array(
                  						'default' => '14px',
                  					),
                  					'line_height' => array(
                  						'default' => '1em',
                  					),
                  				),
                  				'excerpt' => array(
                  					'label'    => esc_html__( 'Default Layout - Excerpt', 'divi-machine' ),
                  					'css'      => array(
                  						'main' => "%%order_class%% ul.products li.product .woocommerce-product-details__short-description",
                  						'important' => 'plugin_only',
                  					),
                  					'font_size' => array(
                  						'default' => '14px',
                  					),
                  					'line_height' => array(
                  						'default' => '1em',
                  					),
                  				),
                  			),
              			'background' => array(
              				'settings' => array(
              					'color' => 'alpha',
              				),
              			),
                  			'button' => array(
                  			),
                  			'box_shadow' => array(
                  				'default' => array(),
                  				'product' => array(
                  					'label' => esc_html__( 'Default Layout - Box Shadow', 'divi-machine' ),
                  					'css' => array(
                  						'main' => "%%order_class%% .products .product",
                  					),
                  					'option_category' => 'layout',
                  					'tab_slug'        => 'advanced',
                  					'toggle_slug'     => 'product',
                  				),
                  			),
                  		);


                      $this->custom_css_fields = array(
                  			'image' => array(
                  				'label'    => esc_html__( 'Default Layout - Image', 'divi-machine' ),
                  				'selector' => '%%order_class%% .et_shop_image',
                  			),
                  			'overlay' => array(
                  				'label'    => esc_html__( 'Default Layout - Overlay', 'divi-machine' ),
                  				'selector' => '%%order_class%% .et_overlay,  %%order_class%% .et_pb_extra_overlay',
                  			),
                  			'title' => array(
                  				'label'    => esc_html__( 'Default Layout - Title', 'divi-machine' ),
                  				'selector' => '%%order_class%% .woocommerce-loop-product__title',
                  			),
                  		);


            $this->help_videos = array(
            );
          }

                  function get_fields() {

                    $options = array();

                    $layout_query = array(
                      'post_type'=>'et_pb_layout'
                      , 'posts_per_page'=>-1
                      , 'meta_query' => array(
                          array(
                              'key' => '_et_pb_predefined_layout',
                              'compare' => 'NOT EXISTS',
                          ),
                      )
                    );
                    $options['none'] = 'No Layout (please choose one)';
                    if ($layouts = get_posts($layout_query)) {
                    foreach ($layouts as $layout) {
                    $options[$layout->ID] = $layout->post_title;
                    }
                    }

                    ///////////////////////////////

                  $acf_fields = DEDMACH_INIT::get_acf_fields();

                    //////////////////////////////


                      $fields = array(
                      'post_type_choose' => array(
                      'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Post Type', 'divi-machine' ),
                        'type'              => 'select',
                				'options'           => et_get_registered_post_type_options( false, false ),
                        'option_category'   => 'configuration',
                        'default'           => 'post',
                        'computed_affects' => array(
                          '__getcarousel',
                        ),
                        'description'       => esc_html__( 'Choose the post type you want to display', 'divi-machine' ),
                      ),
                      'loop_layout' => array(
                        'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Custom Loop Layout', 'divi-machine' ),
                        'type'              => 'select',
                        'option_category'   => 'configuration',
                        'default'           => 'none',
                        'computed_affects' => array(
                          '__getcarousel',
                        ),
                        'options'           => $options,
                        'description'        => esc_html__( 'Choose the layout you have made for each post in the loop.', 'divi-machine' ),
                      ),
// LOOP SETTINGS

            'post_status' => array(
            'toggle_slug'       => 'loop_options',
            'option_category'   => 'configuration',
              'label'             => esc_html__( 'Post Status', 'divi-machine' ),
              'type'              => 'select',
              'options'           => array(
              'publish' => sprintf( esc_html__( 'Publish', 'divi-machine' ) ),
              'pending' => esc_html__( 'Pending', 'divi-machine' ),
              'draft' => esc_html__( 'Draft', 'divi-machine' ),
              'auto-draft' => esc_html__( 'Auto-draft', 'divi-machine' ),
              'future' => esc_html__( 'Future', 'divi-machine' ),
              'private' => esc_html__( 'Private', 'divi-machine' ),
              'inherit' => esc_html__( 'Inherit', 'divi-machine' ),
              ),
              'default' => 'publish',
              'computed_affects' => array(
                '__getcarousel',
              ),
              'description'       => esc_html__( 'Choose the status of the posts you want to show.', 'divi-machine' ),
            ),
'posts_number' => array(
'toggle_slug'       => 'loop_options',
'option_category'   => 'configuration',
  'label'             => esc_html__( 'Post Count', 'divi-machine' ),
  'type'              => 'text',
  'default'           => 10,
  'description'       => esc_html__( 'Choose how many posts you would like to display per page."', 'divi-machine' ),
),
'include_cats' => array(
'toggle_slug'       => 'loop_options',
'option_category'   => 'configuration',
  'label'           => esc_html__( 'Include Categories (comma-seperated)', 'divi-machine' ),
  'type'            => 'text',
  'computed_affects' => array(
    '__getcarousel',
  ),
  'description'     => esc_html__( 'Add a list of categories you want to include to show. This will remove all products that dont have these tags. (comma-seperated)', 'divi-machine' ),
),
'include_tags' => array(
'toggle_slug'       => 'loop_options',
'option_category'   => 'configuration',
  'label'           => esc_html__( 'Tags (comma-seperated)', 'divi-machine' ),
  'type'            => 'text',
  'computed_affects' => array(
    '__getcarousel',
  ),
  'description'     => esc_html__( 'Add a list of tags that you want to include to show. This will remove all products that dont have these tags. (comma-seperated)', 'divi-machine' ),
),
'acf_name' => array(
'toggle_slug'       => 'loop_options',
  'label'             => esc_html__( 'Filter By ACF Name', 'divi-machine' ),
  'type'              => 'select',
  'options'           => $acf_fields,
  'default'           => 'none',
  'computed_affects' => array(
    '__getcarousel',
  ),
  'option_category'   => 'configuration',
  'description'       => esc_html__( 'Filter by this ACF name and then the value below', 'divi-machine' ),
),
'acf_value' => array(
'toggle_slug'       => 'loop_options',
'option_category'   => 'configuration',
  'label'           => esc_html__( 'ACF Value', 'divi-machine' ),
  'type'            => 'text',
  'computed_affects' => array(
    '__getcarousel',
  ),
  'description'     => esc_html__( 'Add the value here, it will show posts only with the value of the ACF field above', 'divi-machine' ),
),
// 'author' => array(
// 'toggle_slug'       => 'loop_options',
// 'option_category'   => 'configuration',
//   'label'           => esc_html__( 'Author/s (comma-seperated)', 'divi-machine' ),
//   'type'            => 'text',
//   'description'     => esc_html__( 'Add a list of authors IDs. (comma-seperated)', 'divi-machine' ),
// ),
'sort_order' => array(
'toggle_slug'       => 'loop_options',
'option_category'   => 'configuration',
  'label'             => esc_html__( 'Sort Order', 'divi-machine' ),
  'type'              => 'select',
  'options'           => array(
  'date' => sprintf( esc_html__( 'Date', 'divi-machine' ) ),
  'title' => esc_html__( 'Title', 'divi-machine' ),
  'ID' => esc_html__( 'ID', 'divi-machine' ),
  'rand' => esc_html__( 'Random', 'divi-machine' ),
  'menu_order' => esc_html__( 'Menu Order', 'divi-machine' ),
  'name' => esc_html__( 'Name', 'divi-machine' ),
  'modified' => esc_html__( 'Modified', 'divi-machine' ),
  ),
  'default' => 'date',
  'computed_affects' => array(
    '__getcarousel',
  ),
  'description'       => esc_html__( 'Choose the sort order of the products.', 'divi-machine' ),
),
'order_asc_desc' => array(
'toggle_slug'       => 'loop_options',
'option_category'   => 'configuration',
  'label'             => esc_html__( 'Order', 'divi-machine' ),
  'type'              => 'select',
  'options'           => array(
    'ASC' => esc_html__( 'Ascending', 'divi-machine' ),
    'DESC' => sprintf( esc_html__( 'Descending', 'divi-machine' ) ),
  ),
  'default' => 'ASC',
  'computed_affects' => array(
    '__getcarousel',
  ),
  'description'       => esc_html__( 'Choose the sort order of the products.', 'divi-machine' ),
),
// CAROUSEL OPTIONS
'posts_number_desktop' => array(
        'default'           => 5,
        'label'             => esc_html__( 'Desktop Images Number in view', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'computed_affects' => array(
          '__getcarousel',
        ),
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_desktop_slide' => array(
        'default'           => 1,
        'label'             => esc_html__( 'Desktop Images Number to Slide', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_tablet' => array(
        'default'           => 4,
        'label'             => esc_html__( 'Tablet Portrait Images Number in view', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_slide_tablet' => array(
        'default'           => 1,
        'label'             => esc_html__( 'Tablet Portrait Images Number to Slide', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_tablet_land' => array(
        'default'           => 3,
        'label'             => esc_html__( 'Tablet Landscape Images Number in view', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_slide_tablet_land' => array(
        'default'           => 1,
        'label'             => esc_html__( 'Tablet Landscape Images Number to Slide', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_mobile' => array(
        'default'           => 1,
        'label'             => esc_html__( 'Mobile Images Number in view', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'posts_number_slide_mobile' => array(
        'default'           => 1,
        'label'             => esc_html__( 'Mobile Images Number to Slide', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Define the number of images that should be displayed per page.', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'       => 'carousel_settings',
      ),
      'left_icon' => array(
      'default'           => "34",
      'label'             => esc_html__( 'Left Icon Code', 'divi-bodyshop-woocommerce' ),
      'type'              => 'text',
      'option_category'   => 'configuration',
      'description'       => esc_html__( 'Set the icon code by going to https://www.elegantthemes.com/blog/resources/elegant-icon-font and scroll down till you see the icons. Input the code that appears after the "x"', 'divi-bodyshop-woocommerce' ),
      'toggle_slug'         => 'carousel_settings',
    ),
    'right_icon' => array(
      'default'           => "35",
      'label'             => esc_html__( 'Right Icon Code', 'divi-bodyshop-woocommerce' ),
      'type'              => 'text',
      'option_category'   => 'configuration',
      'description'       => esc_html__( 'Set the icon code by going to https://www.elegantthemes.com/blog/resources/elegant-icon-font and scroll down till you see the icons. Input the code that appears after the "x"', 'divi-bodyshop-woocommerce' ),
      'toggle_slug'         => 'carousel_settings',
    ),
      'arrows_color' => array(
        'label'             => esc_html__( 'Arrows Color', 'divi-bodyshop-woocommerce' ),
        'type'              => 'color-alpha',
        'custom_color'      => true,
        'toggle_slug'       => 'carousel_settings',
      ),
      'autoplay_speed' => array(
        'default'           => "",
        'label'             => esc_html__( 'Autoplay and delay', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'If you would like it to autoplay - add the delay time of each slide. To remove autoplay - set no text here. Time in milliseconds, example 5 seconds would be "5000".', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'         => 'carousel_settings',
      ),
      'slide_speed' => array(
        'default'           => "300",
        'label'             => esc_html__( 'Slide speed', 'divi-bodyshop-woocommerce' ),
        'type'              => 'text',
        'option_category'   => 'configuration',
        'description'       => esc_html__( 'Set the speed of the slide in milliseconds, for example 1 second will be "1000".', 'divi-bodyshop-woocommerce' ),
        'toggle_slug'         => 'carousel_settings',
      ),




// ADVANCED OPTIONS
'equal_height' => array(
  'label'             => esc_html__( 'Equal Height Grid Cards', 'divi-machine' ),
  'type'              => 'yes_no_button',
  'option_category'   => 'configuration',
  'options'           => array(
    'on'  => esc_html__( 'Yes', 'divi-machine' ),
    'off' => esc_html__( 'No', 'divi-machine' ),
  ),
  'description' => esc_html__( 'Enable this if you have the grid layout and want all your cards to be the same height.', 'divi-machine' ),
  'toggle_slug'       => 'extra_options',
),
'link_whole_gird' => array(
'toggle_slug'       => 'extra_options',
'label'             => esc_html__( 'Link each layout to product', 'divi-machine' ),
'type'              => 'yes_no_button',
'options'           => array(
'off' => esc_html__( 'No', 'divi-machine' ),
'on'  => esc_html__( 'Yes', 'divi-machine' ),
),
'description'        => esc_html__( 'Enable this if you want to link each loop layout to the product. For example if you want the whole "grid card" to link to the product page. NB: You need to have no other links on the loop layout so do not link the image or the title to the product page.', 'divi-machine' ),
),
'align_last_bottom' => array(
'toggle_slug'       => 'extra_options',
'label'             => esc_html__( 'Align last module at the bottom', 'divi-machine' ),
'type'              => 'yes_no_button',
'options'           => array(
'off' => esc_html__( 'No', 'divi-machine' ),
'on'  => esc_html__( 'Yes', 'divi-machine' ),
),
'description'        => esc_html__( 'Enable this to align the last module (probably the add to cart) at the bottom. Works well when using the equal height.', 'divi-machine' ),
),
'__getcarousel' => array(
				'type' => 'computed',
				'computed_callback' => array( 'de_mach_carousel_code', 'get_carousel' ),
				'computed_depends_on' => array(
          'post_type_choose',
'loop_layout',
'post_status',
'include_cats',
'include_tags',
'acf_name',
'acf_value',
'sort_order',
'order_asc_desc',
'posts_number_desktop',
				),
			),


                      );

                      return $fields;
                  }


                  public static function get_carousel ( $args = array(), $conditional_tags = array(), $current_page = array() ){
                    if (!is_admin()) {
                      return;
                    }

            ob_start();

            $loop_layout        = $args['loop_layout'];
            $columns            = $args['posts_number_desktop'];
            $post_type_choose            = $args['post_type_choose'];


            $post_status     = $args['post_status'];
            $include_cats     = $args['include_cats'];
            $include_tags     = $args['include_tags'];
            $acf_name     = $args['acf_name'];
            $acf_value     = $args['acf_value'];
            $sort_order     = $args['sort_order'];
            $order_asc_desc     = $args['order_asc_desc'];


            $post_slug = DEDMACH_INIT::get_vb_post_type();

                    $get_cpt_args = array(
                      'post_type' => $post_type_choose,
                      'post_status' => $post_status,
                      'posts_per_page' => $columns,
                      'orderby' => $sort_order,
                      'order' => $order_asc_desc,
                  );

                  if ($include_cats != "") {
                      $get_cpt_args['category_name'] = $include_cats;
                  }

                  if ($include_tags != "") {
                      $get_cpt_args['tag'] = $include_tags;
                  }

                    query_posts( $get_cpt_args );


                    if ($loop_layout == "none") {
                        echo "Please create a custom loop layout and specify it in the settings.";
                    } else {

                      if ( have_posts() ) {
                        ?>
                        <div class="dmach_carousel_container">
                        <button class="slick-prev slick-arrow single" type="button">Previous</button>
                        <div class="slick-list draggable">
                          <?php
                        while ( have_posts() ) {
                          the_post();

                        ?>

                            <?php
                            echo apply_filters('the_content', get_post_field('post_content', $loop_layout));
                            ?>


                        <?php
                        } // end while

                        ?>
                        </div>
                        <button class="slick-next slick-arrow single" type="button">Next</button>
                        </div>

                        <style>
                        .slick-next:before, .slick-prev:before {
                          line-height: 1;
                          color: #fff;
                        }
                        .dmach_carousel_container {opacity: 1 !important;}
                        .et_pb_de_mach_acf_slider_containter_nav, .et_pb_de_mach_acf_slider_containter  {
                              position: relative;
                        }
                        .slick-next, .slick-prev {
                            font-size: 0;
                            line-height: 0;
                            position: absolute;
                            top: 50%;
                            display: block;
                            width: 20px;
                            height: 20px;
                            padding: 0;
                            -webkit-transform: translate(0, -50%);
                            -ms-transform: translate(0, -50%);
                            transform: translate(0, -50%);
                            cursor: pointer;
                            color: transparent;
                            border: none;
                            outline: 0;
                            background: 0 0;
                        }
                        .slick-prev {
                            left: -25px;
                        }
                        .slick-next {
                            right: -25px;
                        }
                        .slick-dots {
                            bottom: -50px;
                        }
                        .slick-dots {
                            position: absolute;
                            bottom: -25px;
                            display: block;
                            width: 100%;
                            padding: 0;
                            margin: 0;
                            list-style: none;
                            text-align: center;
                        }
                        .slick-dots, .slick-dots li {
                            list-style-type: none !important;
                        }
                        .slick-dots li {
                            position: relative;
                            display: inline-block;
                            width: 20px;
                            height: 20px;
                            margin: 0 5px;
                            padding: 0;
                            cursor: pointer;
                        }
                        .et_pb_de_mach_acf_slider .slick-dots li button {
                            text-indent: 100%;
                            white-space: nowrap;
                            height: 17px;
                            width: 17px;
                            border-radius: 50%;
                            font-size: 0;
                            cursor: pointer;
                            color: transparent;
                            border: 0;
                            outline: 0;
                            padding: 5px;
                            line-height: 0;
                            display: block;
                        }
                        .slick-dots li button {
                            background: #ececec;
                          }
                        .slick-dots li.slick-active button {
                            background: #000000;
                        }
                        </style>
                        <?php

                        // retrieve the styles for the modules
                        $internal_style = ET_Builder_Element::get_style();
                        // reset all the attributes after we retrieved styles
                        ET_Builder_Element::clean_internal_modules_styles( false );
                        $et_pb_rendering_column_content = false;

                        // append styles
                        if ( $internal_style ) {
                    ?>
                        <div class="dmach-inner-styles">
                    <?php
                            $cleaned_styles = str_replace("#et-boc .et-l","#et-boc .et-l .dmach_carousel_container", $internal_style);
                            $cleaned_styles = str_replace(".et_pb_section_",".dmach_carousel_container .et_pb_section_", $cleaned_styles);
                            $cleaned_styles = str_replace(".et_pb_row_",".dmach_carousel_container .et_pb_row_", $cleaned_styles);
                            $cleaned_styles = str_replace(".et_pb_module_",".dmach_carousel_container .et_pb_module_", $cleaned_styles);
                            $cleaned_styles = str_replace(".et_pb_column_",".dmach_carousel_container .et_pb_column_", $cleaned_styles);
                            $cleaned_styles = str_replace(".et_pb_de_mach_",".dmach_carousel_container .et_pb_de_mach_", $cleaned_styles);
                            $cleaned_styles = str_replace(".dmach_carousel_container .dmach_carousel_container",".dmach_carousel_container", $cleaned_styles);
                            $cleaned_styles = str_replace(".dmach_carousel_container .et_pb_section .dmach_carousel_container",".dmach_carousel_container", $cleaned_styles);

                            printf(
                                '<style type="text/css" class="dmach_ajax_inner_styles">
                                  .dmach_carousel_container div.et_pb_section {background-color: transparent;background-image: inherit !important;}
                                  %1$s
                                </style>',
                                et_core_esc_previously( $cleaned_styles )
                            );
                    ?>
                        </div>
                    <?php
                        }


                      } // end if

                    }



                      $data = ob_get_clean();

                    return $data;

                    }


                  function render( $attrs, $content = null, $render_slug ) {

                    if (is_admin()) {
                        return;
                    }

                    $loop_layout       = $this->props['loop_layout'];
                    $post_type_choose       = $this->props['post_type_choose'];
                    $post_status       = $this->props['post_status'];
                    $include_cats       = $this->props['include_cats'];
                    $include_tags       = $this->props['include_tags'];
                    // $author       = $this->props['author'];
                    $sort_order       = $this->props['sort_order'];
                    $order_asc_desc       = $this->props['order_asc_desc'];
                    $posts_number       = $this->props['posts_number'];


                    $link_whole_gird      = $this->props['link_whole_gird'];

                    $acf_name      = $this->props['acf_name'];
                    $acf_value      = $this->props['acf_value'];


                    $equal_height      = $this->props['equal_height'];
                    $align_last_bottom 		= $this->props['align_last_bottom'];


                    $left_icon             = $this->props['left_icon']; // Left Icon
                    $right_icon            = $this->props['right_icon']; // Right Icon
                    $autoplay_speed           = $this->props['autoplay_speed']; // autoplay_speed
                    $slide_speed           = $this->props['slide_speed']; // slide_speed
                    $arrows_color       = $this->props['arrows_color'];   //Arrows Color

                    $posts_number_desktop          = $this->props['posts_number_desktop'];                           // desktop number
                    $posts_number_desktop_slide        = $this->props['posts_number_desktop_slide'];                 // desktop number slides
                    $posts_number_tablet          = $this->props['posts_number_tablet'];                             // tablet number
                    $posts_number_slide_tablet          = $this->props['posts_number_slide_tablet'];                 // tablet number slides
                    $posts_number_tablet_land          = $this->props['posts_number_tablet_land'];                   // tablet landscape number
                    $posts_number_slide_tablet_land          = $this->props['posts_number_slide_tablet_land'];       // tablet landscape number slides
                    $posts_number_mobile          = $this->props['posts_number_mobile'];                             // mobile number
                    $posts_number_slide_mobile          = $this->props['posts_number_slide_mobile'];


                                        if ($autoplay_speed != "") {
                                          $autospeed = $autoplay_speed;
                                          $autoplay = "autoplay: true,";
                                        }
                                        else {
                                          $autospeed = "0";
                                          $autoplay = "autoplay: false,";
                                        }

                    $num = mt_rand(100000,999999);
                    $css_class              = $render_slug . "_" . $num;

                    if ( $equal_height == 'on' ) {
                      $this->add_classname('same-height-cards');
                    }
                    if ( $align_last_bottom == 'on' ) {
                      $this->add_classname('align-last-module');
                    }


                    wp_enqueue_script( 'dmach-carousel-js',  DE_DMACH_PATH_URL . '/scripts/carousel.min.js', array(), DE_DMACH_VERSION, true );
                    wp_enqueue_style( 'dmach-carousel-css', DE_DMACH_PATH_URL . '/styles/carousel.min.css', array(), DE_DMACH_VERSION );

                  //////////////////////////////////////////////////////////////////////

                    ob_start();




                      global $wp_query, $wpdb, $post, $woocommerce;
                    $args = array(
                            'post_type'           => $post_type_choose,
                            'post_status'         => $post_status,
                        		'posts_per_page' => (int) $posts_number,
                            'orderby'        => $sort_order,
                            'order' => $order_asc_desc
                        );

                  if ($include_cats != "") {
                    $args['category_name'] = $include_cats;
                  }

                  if ($include_tags != "") {
                    $args['tag'] = $include_tags;
                  }


                  if ($acf_name != "none") {
                    $args['meta_key'] = $acf_name;
                  }

                  if ($acf_value != "") {
                    $acf_value = explode(',', $acf_value);
                    $args['meta_value'] = $acf_value;
                  }




                  // if ($author != "") {
                  //   $args['author_name'] = $author;
                  // }
                    $args = apply_filters('dmach_archive_post_args', $args);

                      query_posts( $args );


                      if ($loop_layout == "none") {
                        echo "Please create a custom loop layout and specify it in the settings.";
                      } else {


                    if ( have_posts() ) {

                      ?>
                      <div class="<?php echo $css_class ?> dmach_carousel_container">
                      <?php

                      while ( have_posts() ) {
                				the_post();
                        setup_postdata( $post );

                        echo apply_filters('the_content', get_post_field('post_content', $loop_layout));


                      } // end while have posts

                      ?>
                      </div>
                      <?php




                } // end if have posts


                }


                    wp_reset_query();

?>
<script>
  jQuery(document).ready(function($){
    $(".<?php echo $css_class ?>.dmach_carousel_container").slick({
      dots: false,
      infinite: true,
slidesToShow: <?php echo $posts_number_desktop ?>,
slidesToScroll:<?php echo $posts_number_desktop_slide ?>,
<?php echo $autoplay ?>
autoplaySpeed: <?php echo $autospeed ?>,
responsive: [
   {
     breakpoint: 1030,
     settings: {
       slidesToShow: <?php echo $posts_number_tablet ?>,
       slidesToScroll: <?php echo $posts_number_slide_tablet ?>,
     } },
   {
     breakpoint: 980,
     settings: {
       slidesToShow: <?php echo $posts_number_tablet_land ?>,
       slidesToScroll: <?php echo $posts_number_slide_tablet_land ?>
     } },
   {
     breakpoint: 580,
     settings: {
       slidesToShow: <?php echo $posts_number_mobile ?>,
       slidesToScroll: <?php echo $posts_number_slide_mobile ?>
     } }
 ]
});
});
    </script>
<?php

$css_styles = '<style id="dmach-'.$css_class.'-carousel-custom-css">';

$css_styles .= sprintf(
  '<style>
  .%4$s.dmach_carousel_container .slick-prev::before {
    content: "\%1$s";
   }
  .%4$s.dmach_carousel_container .slick-next::before {
      content: "\%2$s";
   }
  .%4$s.dmach_carousel_container .slick-next::before, .%4$s.dmach_carousel_container .slick-prev::before {
    color: %3$s;
  }

  </style>',
  $left_icon,
$right_icon,
$arrows_color,
$css_class
);

$css_styles .= '</style>';
//minify it
$css_styles_min = str_replace( array("\r\n", "\r", "\n", "\t", '  ', '    ', '    '), '', $css_styles );
echo $css_styles_min; // phpcs:ignore

                    $data = ob_get_clean();

                   //////////////////////////////////////////////////////////////////////

                  return $data;



              }

            }

            new de_mach_carousel_code;

?>
