<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class de_mach_repeater_code extends ET_Builder_Module {

public $vb_support = 'on';

protected $module_credits = array(
  'module_uri' => DE_DMACH_PRODUCT_URL,
  'author'     => DE_DMACH_AUTHOR,
  'author_uri' => DE_DMACH_URL,
);

                function init() {
                    $this->name       = esc_html__( '.Repeater - Divi Machine', 'divi-machine' );
                    $this->slug = 'et_pb_de_mach_repeater';
                		$this->vb_support      = 'on';
                		$this->child_slug      = 'et_pb_de_mach_acf_item';
                		$this->child_item_text = esc_html__( 'ACF Item', 'et_builder' );


                    $this->fields_defaults = array(
                    // 'loop_layout'         => array( 'on' ),
                    );

          $this->settings_modal_toggles = array(
      			'general' => array(
      				'toggles' => array(
      					'main_content' => esc_html__( 'Main Options', 'divi-machine' ),
      				),
      			),
      			'advanced' => array(
      				'toggles' => array(
      					'text' => esc_html__( 'Text', 'divi-machine' ),
      				),
      			),

      		);


                      $this->main_css_element = '%%order_class%%';


                      $this->advanced_fields = array(
                  			'fonts' => array(
                  				'title' => array(
                  					'label'    => esc_html__( 'Item', 'divi-machine' ),
                  					'css'      => array(
                  						'main' => "%%order_class%% ul.products li.product .woocommerce-loop-product__title",
                  						'important' => 'plugin_only',
                  					),
                  					'font_size' => array(
                  						'default' => '14px',
                  					),
                  					'line_height' => array(
                  						'default' => '1em',
                  					),
                  				),
                  			),
              			'background' => array(
              				'settings' => array(
              					'color' => 'alpha',
              				),
              			),
                  			'button' => array(
                  			),
                  			'box_shadow' => array(
                  				'default' => array(),
                  				'product' => array(
                  					'label' => esc_html__( 'Default Layout - Box Shadow', 'divi-machine' ),
                  					'css' => array(
                  						'main' => "%%order_class%%",
                  					),
                  					'option_category' => 'layout',
                  					'tab_slug'        => 'advanced',
                  					'toggle_slug'     => 'product',
                  				),
                  			),
                  		);


                      $this->custom_css_fields = array(
                  		);


            $this->help_videos = array(
            );
          }




                  function get_fields() {

                    $layout_query = array(
                        'post_type'=>'et_pb_layout',
                        'posts_per_page'=>-1,
                        'meta_query' => array(
                            array(
                                'key' => '_et_pb_predefined_layout',
                                'compare' => 'NOT EXISTS',
                            ),
                        )
                    );
                    $options['none'] = 'No Layout (please choose one)';
                    if ($layouts = get_posts($layout_query)) {
                        foreach ($layouts as $layout) {
                            $options[$layout->ID] = $layout->post_title;
                        }
                    }



                    $acf_fields = DEDMACH_INIT::get_acf_fields();

                      $fields = array(
                        'repeater_type' => array(
                        'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Repeater Type', 'divi-machine' ),
                        'type'              => 'select',
                        'option_category'   => 'configuration',
                        'default'   => 'acf_item',
                        'options'           => array(
                        'acf_item'  => esc_html__( 'ACF Items', 'divi-machine' ),
                        'repeater_field'  => esc_html__( 'ACF Repeater Field', 'divi-machine' )
                        ),
                        'affects'         => array(
                            'repeater_loop_layout',
                            'repeater_name'
                        ),
                        'computed_affects' => array(
                          '__getacfitem',
                        ),
                        'description'        => esc_html__( 'How many columns do you want to see', 'divi-machine' ),
                        ),
                      'repeater_name' => array(
                      'toggle_slug'       => 'main_content',
                        'label'             => esc_html__( 'Repeater Name', 'divi-machine' ),
                        'type'              => 'select',
                        'options'           => $acf_fields,
                        'default'           => 'none',
                				'computed_affects' => array(
                					'__getacfitem',
                				),
                        'depends_show_if' => 'repeater_field',
                        'option_category'   => 'configuration',
                        'description'       => esc_html__( 'Add the name of your repeater field', 'divi-machine' ),
                      ),
                        'repeater_loop_layout' => array(
                            'toggle_slug'       => 'main_content',
                            'label'             => esc_html__( 'Repeater Loop Layout', 'divi-machine' ),
                            'type'              => 'select',
                            'option_category'   => 'configuration',
                            'default'           => 'none',
                            'computed_affects' => array(
                              '__getacfitem',
                            ),
                            'depends_show_if' => 'repeater_field',
                            'options'           => $options,
                            'description'        => esc_html__( 'Choose the layout you have made for each repeater in the loop.', 'divi-machine' ),
                        ),
                        'columns' => array(
                        'toggle_slug'       => 'grid_options',
                        'label'             => esc_html__( 'Grid Columns', 'divi-machine' ),
                        'type'              => 'select',
                        'option_category'   => 'layout',
                        'default'   => '4',
                        'options'           => array(
                        '1'  => esc_html__( 'One', 'divi-machine' ),
                        '2'  => esc_html__( 'Two', 'divi-machine' ),
                        '3' => esc_html__( 'Three', 'divi-machine' ),
                        '4' => esc_html__( 'Four', 'divi-machine' ),
                        '5' => esc_html__( 'Five', 'divi-machine' ),
                        '6' => esc_html__( 'Six', 'divi-machine' ),
                        ),
                        'computed_affects' => array(
                          '__getacfitem',
                        ),
                        'description'        => esc_html__( 'How many columns do you want to see', 'divi-machine' ),
                        ),
                        'columns_tablet' => array(
                        'toggle_slug'       => 'grid_options',
                        'label'             => esc_html__( 'Tablet Grid Columns', 'divi-machine' ),
                        'type'              => 'select',
                        'option_category'   => 'layout',
                        'default'   => '2',
                        'options'           => array(
                        '1'  => esc_html__( 'One', 'divi-machine' ),
                        '2'  => esc_html__( 'Two', 'divi-machine' ),
                        '3' => esc_html__( 'Three', 'divi-machine' ),
                        '4' => esc_html__( 'Four', 'divi-machine' ),
                        '5' => esc_html__( 'Five', 'divi-machine' ),
                        '6' => esc_html__( 'Six', 'divi-machine' ),
                        ),
                        'computed_affects' => array(
                          '__getacfitem',
                        ),
                        'description'        => esc_html__( 'How many columns do you want to see on tablet', 'divi-machine' ),
                        ),
                        'columns_mobile' => array(
                        'toggle_slug'       => 'grid_options',
                        'label'             => esc_html__( 'Mobile Grid Columns', 'divi-machine' ),
                        'type'              => 'select',
                        'option_category'   => 'layout',
                        'default'   => '1',
                        'options'           => array(
                        '1'  => esc_html__( 'One', 'divi-machine' ),
                        '2'  => esc_html__( 'Two', 'divi-machine' ),
                        '3' => esc_html__( 'Three', 'divi-machine' ),
                        '4' => esc_html__( 'Four', 'divi-machine' ),
                        '5' => esc_html__( 'Five', 'divi-machine' ),
                        '6' => esc_html__( 'Six', 'divi-machine' ),
                        ),
                        'computed_affects' => array(
                          '__getacfitem',
                        ),
                        'description'        => esc_html__( 'How many columns do you want to see on mobile', 'divi-machine' ),
                        ),
                        'custom_gutter_repeater' => array(
                          'label'           => esc_html__( 'Custom Gutter Width', 'divi-bodyshop-woocommerce' ),
                          'type'            => 'range',
                          'option_category' => 'layout',
                          'toggle_slug'     => 'grid_options',
                          'default'         => '3',
                          'default_unit'    => ' ',
                          'default_on_front'=> '',
                          'allowed_units'   => array( ' ' ),
                          'range_settings' => array(
                            'min'  => '1',
                            'max'  => '4',
                            'step' => '1',
                          ),
                          'computed_affects' => array(
                            '__getacfitem',
                          ),
                        ),
                        '_getrepeater'  => array(
                          'type' => 'computed',
                          'computed_callback' => array( 'de_mach_repeater_code', 'get_repeated_content' ),
                          'computed_depends_on' => array(
                            'columns',
                            'columns_tablet',
                            'columns_mobile',
                            'custom_gutter_repeater'
                          ),
                        ),
                      );

                      return $fields;
                  }

                  public static function get_repeated_content( $args = array(), $conditional_tags = array(), $current_page = array() ){
                  ob_start();

                  $custom_gutter_repeater = $args['custom_gutter_repeater'];
                  $columns = $args['columns'];
                  $columns_tablet = $args['columns_tablet'];
                  $columns_mobile = $args['columns_mobile'];


                  ?>
                  <div class="et_pb_de_mach_archive_loop et_pb_gutters<?php echo $custom_gutter_repeater ?>">
                  <div class="et_pb_de_mach_archive_loop repeater-cont grid col-<?php echo $columns?> col-tab-<?php echo $columns_tablet?> col-mob-<?php echo $columns_mobile?>">
                    <div class="grid-posts">

                  <?php

                    $data = ob_get_clean();
                    return $data;
                  }

                  public function get_repeater_items_content() {
                		return $this->content;
                	}



                  function render( $attrs, $content = null, $render_slug ) {

                    // if (is_admin()) {
                    //     return;
                    // }

                    $columns      = $this->props['columns'];
                    $columns_tablet      = $this->props['columns_tablet'];
                    $columns_mobile      = $this->props['columns_mobile'];
                    $custom_gutter_repeater      = $this->props['custom_gutter_repeater'];

                    $repeater_type            = $this->props['repeater_type'];
                    $repeater_name            = $this->props['repeater_name'];
                    $repeater_loop_layout            = $this->props['repeater_loop_layout'];

		                $all_repeater_content = $this->get_repeater_items_content();

                  //////////////////////////////////////////////////////////////////////

                    ob_start();

                    ?>
                    <div class="et_pb_de_mach_archive_loop et_pb_gutters<?php echo $custom_gutter_repeater ?>">
                    <div class="et_pb_de_mach_archive_loop repeater-cont grid col-<?php echo $columns?> col-tab-<?php echo $columns_tablet?> col-mob-<?php echo $columns_mobile?>">
                      <div class="grid-posts">

                    <?php

                    if ($repeater_type == "repeater_field") {


                      if( have_rows($repeater_name) ):

 	                     // loop through the rows of data
                       while ( have_rows($repeater_name) ) : the_row();

                       echo apply_filters('the_content', get_post_field('post_content', $repeater_loop_layout));

                     endwhile;

                   endif;


                    } else {
                      echo $all_repeater_content;
                    }

                    // echo apply_filters('the_content', get_post_field('post_content', $loop_layout));


                    ?>

                  </div>
                  </div>
                </div>
                    <?php
                    $data = ob_get_clean();



                   //////////////////////////////////////////////////////////////////////

                  return $data;



              }

            }

            new de_mach_repeater_code;

?>
