<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class de_mach_search_posts_item_code extends ET_Builder_Module {

public $vb_support = 'on';

protected $module_credits = array(
 'module_uri' => DE_DMACH_PRODUCT_URL,
 'author'     => DE_DMACH_AUTHOR,
 'author_uri' => DE_DMACH_URL,
);

               function init() {
                   $this->name       = esc_html__( 'Search/Filter Item', 'divi-machine' );
                   $this->slug = 'et_pb_de_mach_search_posts_item';
                   $this->vb_support      = 'on';
                   $this->type                        = 'child';
                   $this->child_title_var             = 'title';
                   $this->advanced_setting_title_text = esc_html__( 'New Search/Filter Item', 'et_builder' );
                   $this->settings_text               = esc_html__( 'Search/Filter Item Settings', 'et_builder' );


                   $this->fields_defaults = array(
                   // 'loop_layout'         => array( 'on' ),
                   );

         $this->settings_modal_toggles = array(
           'general' => array(
             'toggles' => array(
               'main_content' => esc_html__( 'Main Options', 'divi-machine' ),
                 'layout' => esc_html__( 'Layout Options', 'divi-machine' ),
               'text_filter' => esc_html__( 'Text Filter Options', 'divi-machine' ),
               'select_filter' => esc_html__( 'Select Filter Options', 'divi-machine' ),
               'tags_filter' => esc_html__( 'Category / Tags Filter Options', 'divi-machine' ),
               'radio_filter' => esc_html__( 'Checkbox / radio Filter Options', 'divi-machine' ),
               'range_filter' => esc_html__( 'Number/Range Filter Options', 'divi-machine' ),
               'filter_style' => esc_html__( 'Radio / Checkbox Style', 'divi-machine' ),
             ),
           ),
           'advanced' => array(
             'toggles' => array(
               'text' => esc_html__( 'Text', 'divi-machine' ),
             ),
           ),

         );


                     $this->main_css_element = '%%order_class%%';


                     $this->advanced_fields = array(
                       'fonts' => array(
                         'title' => array(
                           'label'    => esc_html__( 'Item', 'divi-machine' ),
                           'css'      => array(
                             'main' => "%%order_class%%",
                             'important' => 'plugin_only',
                           ),
                           'font_size' => array(
                             'default' => '14px',
                           ),
                           'line_height' => array(
                             'default' => '1em',
                           ),
                         ),
                           'radio_button_text' => array(
                             'label'    => esc_html__( 'Checkbox / Radio Button Style', 'divi-machine' ),
                             'css'      => array(
                               'main' => "%%order_class%% .dmach-radio-buttons .et_pb_contact_field_radio label",
                               'important' => 'plugin_only',
                             ),
                             'font_size' => array(
                               'default' => '14px',
                             ),
                             'line_height' => array(
                               'default' => '1em',
                             ),
                           ),
                           'radio_button_text_checked' => array(
                             'label'    => esc_html__( 'Checkbox / Radio Button Checked Style', 'divi-machine' ),
                             'css'      => array(
                               'main' => "%%order_class%% .dmach-radio-buttons .et_pb_contact_field_radio input:checked+label",
                               'important' => 'plugin_only',
                             ),
                             'font_size' => array(
                               'default' => '14px',
                             ),
                             'line_height' => array(
                               'default' => '1em',
                             ),
                           ),
                           'range_primary_text' => array(
                             'label'    => esc_html__( 'Range Primary', 'divi-machine' ),
                             'css'      => array(
                               'main' => "%%order_class%% .irs-from, %%order_class%% .irs-to, %%order_class%% .irs-single",
                               'important' => 'plugin_only',
                             ),
                             'font_size' => array(
                               'default' => '14px',
                             ),
                             'line_height' => array(
                               'default' => '1em',
                             ),
                           ),
                             'range_secondary_text' => array(
                               'label'    => esc_html__( 'Range Secondary', 'divi-machine' ),
                               'css'      => array(
                                 'main' => "%%order_class%% .irs-min, %%order_class%% .irs-max",
                                 'important' => 'plugin_only',
                               ),
                             'font_size' => array(
                               'default' => '14px',
                             ),
                             'line_height' => array(
                               'default' => '1em',
                             ),
                           ),
                       ),
                   'background' => array(
                     'settings' => array(
                       'color' => 'alpha',
                     ),
                   ),
                       'button' => array(
                       ),
                       'height'                => array(
                         'css' => array(
                           'main' => implode(', ', array(
                             '%%order_class%% input[type=text]',
                             '%%order_class%% input[type=email]',
                             '%%order_class%% textarea',
                             '%%order_class%%[data-type=checkbox]',
                             '%%order_class%%[data-type=radio]',
                             '%%order_class%%[data-type=select]',
                             '%%order_class%%[data-type=select] select',
                           ))
                         )
                       ),
                       'box_shadow' => array(
                         'default' => array(),
                         'product' => array(
                           'label' => esc_html__( 'Default Layout - Box Shadow', 'divi-machine' ),
                           'css' => array(
                             'main' => "%%order_class%% .products .product",
                           ),
                           'option_category' => 'layout',
                           'tab_slug'        => 'advanced',
                           'toggle_slug'     => 'product',
                         ),
                       ),
                     );


                     $this->custom_css_fields = array(
                     );


           $this->help_videos = array(
           );
         }

                 function get_fields() {
                   $et_accent_color = et_builder_accent_color();

                   ///////////////////////////////

                   $acf_fields = DEDMACH_INIT::get_acf_fields();

                   //////////////////////////////


                     $fields = array(
     'title' => array(
       'label'           => esc_html__( 'Admin Filter Name', 'et_builder' ),
       'type'            => 'text',
       'description'     => esc_html__( 'Change the name for the filter for admin purposes ONLY, this is just used so you can see what the filter is.', 'et_builder' ),
       'toggle_slug'     => 'main_content',
       'dynamic_content' => 'text',
       'option_category' => 'configuration',
     ),

     'filter_post_type' => array(
     'toggle_slug'       => 'main_content',
       'label'             => esc_html__( 'What do you want to search/filter?', 'divi-machine' ),
       'type'              => 'select',
       'options'           => array(
       'category'          => 'Category',
       'tags'    => 'Tags',
         'acf'        => 'Advanced Custom Field (ACF Plugin)',
         'search'          => 'Search Text',
         // 'sort'        => 'Sort Posts (filter only)',
         // 'date'        => 'Post Date (filter only)',
         'posttypes'          => 'Post Type Select (Search only)',
       ),
       'default'           => 'category',
       'affects'         => array(
         'text_placeholder',
         'acf_name',
         'acf_filter_type',
         'select_options'
       ),
       'option_category'   => 'configuration',
       'description'       => esc_html__( 'Choose what you want to search or filter', 'divi-machine' ),
     ),
     'select_options' => array(
       'label'           => esc_html__( 'Posts to Search', 'et_builder' ),
       'type'            => 'sortable_list',
       'option_category' => 'configuration',
       'depends_show_if' => 'posttypes',
       'toggle_slug'     => 'main_content',
       'description'       => esc_html__( 'Enter in the post types you want by their slug (lowercase no spaces) - we will then find the posts you want the customer to choose from to search', 'divi-machine' ),
     ),
     'post_type_choose' => array(
     'toggle_slug'       => 'main_content',
       'label'             => esc_html__( 'Post Type', 'divi-machine' ),
       'type'              => 'select',
       'options'           => et_get_registered_post_type_options( false, false ),
       'option_category'   => 'configuration',
       'default'           => 'post',
       'description'       => esc_html__( 'Choose the post type you want to search the category for', 'divi-machine' ),
     ),
                     'acf_name' => array(
                     'toggle_slug'       => 'main_content',
                       'label'             => esc_html__( 'ACF Name', 'divi-machine' ),
                       'type'              => 'select',
                       'options'           => $acf_fields,
                       'default'           => 'none',
                       'depends_show_if'   => 'acf',
                       'option_category'   => 'configuration',
                       'description'       => esc_html__( 'Add the name of the ACF you want to display here', 'divi-machine' ),
                     ),
                     'acf_filter_type' => array(
                     'toggle_slug'       => 'main_content',
                       'label'             => esc_html__( 'Filter Type', 'divi-machine' ),
                       'type'              => 'select',
                       'depends_show_if'   => 'acf',
                       'options'           => array(
                         'select'          => 'Select',
                         'number_range'    => 'Number / Range',
                         'radio'        => 'Checkbox / Radio Buttons'
                       ),
                       'default'           => 'select',
                       'affects'         => array(
                         'default_num',
                         'select_placeholder',
                         'radio_style',
                         'radio_select',
                         'radio_button_background_color',
                         'radio_button_background_color_selected',
                         'radio_button_background_color_selected_text',
                         'range_type',
                         'range_step',
                         'range_skin',
                         'range_hide_min_max',
                         'range_hide_from_to',
                         'range_prettify_enabled',
                         'range_prettify_separator',
                         'range_prefix',
                         'range_postfix'
                       ),
                       'option_category'   => 'configuration',
                       'description'       => esc_html__( 'Choose how you want the filter to be displayed', 'divi-machine' ),
                     ),
                     'acf_filter_width' => array(
                     'toggle_slug'       => 'main_content',
                       'label'             => esc_html__( 'Filter Width', 'divi-machine' ),
                       'type'              => 'select',
                       'options'           => array(
                         'et_pb_column_4_4'        => 'Full (4/4)',
                         'et_pb_column_3_4'        => 'Three Quaters (3/4)',
                         'et_pb_column_2_3'        => 'Two Thirds (2/3)',
                         'et_pb_column_1_2'        => 'Half (1/2)',
                         'et_pb_column_1_3'        => 'Third (1/3)',
                         'et_pb_column_1_4'        => 'Quater (1/4)',
                       ),
                       'default'           => 'et_pb_column_4_4',
                       'option_category'   => 'configuration',
                       'description'       => esc_html__( 'Choose hthe width of the filter', 'divi-machine' ),
                     ),
                     'show_label' => array(
                       'label' => esc_html__( 'Show Label', 'divi-machine' ),
                       'type' => 'yes_no_button',
                       'options_category' => 'configuration',
                       'options' => array(
                         'on' => esc_html__( 'Yes', 'divi-machine' ),
                         'off' => esc_html__( 'No', 'divi-machine' ),
                       ),
                       'affects' => array(
                         'custom_label'
                       ),
                       'default' => 'on',
                       'description' => esc_html__( 'Enable or disable the label.', 'divi-machine' ),
                       'toggle_slug' => 'element_options',
                     ),
                     'custom_label' => array(
                     'toggle_slug'       => 'element_options',
                       'label'             => esc_html__( 'Custom label (leave blank for default label)', 'divi-machine' ),
                       'type'              => 'text',
                       'option_category'   => 'configuration',
                       'depends_show_if'   => 'on',
                       'description'       => esc_html__( 'Add a custom label here or leave it blank to get the default label.', 'divi-machine' ),
                     ),
// TEXT FILTER
'text_placeholder' => array(
'toggle_slug'       => 'text_filter',
 'label'             => esc_html__( 'Placeholder Text', 'divi-machine' ),
 'type'              => 'text',
 'option_category'   => 'configuration',
 'depends_show_if'   => 'search',
 'description'       => esc_html__( 'Add the placeholder for the text input.', 'divi-machine' ),
),
// Select FILTER
'select_placeholder' => array(
'toggle_slug'       => 'select_filter',
'label'             => esc_html__( 'First Option Text', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => '-- Select Option --',
'depends_show_if'   => 'select',
'description'       => esc_html__( 'Choose what the first option of the select option will be.', 'divi-machine' ),
),
// LAYOUT OPTIONS
'radio_select' => array(
'toggle_slug'       => 'radio_filter',
 'label'             => esc_html__( 'Checkbox / Radio Functionality', 'divi-machine' ),
 'type'              => 'select',
 'options'           => array(
 'radio'       => esc_html__( 'Choose One', 'divi-machine' ),
 'checkbox'       => esc_html__( 'Multiple Select', 'divi-machine' ),
 ),
 'option_category'   => 'configuration',
 'default'           => 'radio',
 'depends_show_if'   => 'radio',
 'description'       => esc_html__( 'Choose the style of your radio buttons', 'divi-machine' ),
),
'radio_style' => array(
'toggle_slug'       => 'radio_filter',
 'label'             => esc_html__( 'Checkbox / Radio Style', 'divi-machine' ),
 'type'              => 'select',
 'options'           => array(
 'normal'       => esc_html__( 'Normal', 'divi-machine' ),
 'tick_box'       => esc_html__( 'Tick Boxes', 'divi-machine' ),
 'buttons'       => esc_html__( 'Buttons', 'divi-machine' ),
 'select'       => esc_html__( 'Select Drop Down', 'divi-machine' ),
 ),
 'option_category'   => 'configuration',
 'default'           => 'normal',
 'depends_show_if'   => 'radio',
 'description'       => esc_html__( 'Choose the style of your radio buttons', 'divi-machine' ),
),
  // 'checkbox_color' => array(
  //   'label'             => esc_html__( 'Checkbox Checked Color', 'divi-bodyshop-woocommerce' ),
  //   'type'              => 'color-alpha',
  //   'custom_color'      => true,
  //   'default'	=> et_get_option( 'accent_color', '#2ea3f2' ),
  //   'toggle_slug'       => 'radio_filter',
  //   'option_category'   => 'configuration',
  // ),
'radio_inline' => array(
'toggle_slug'       => 'radio_filter',
 'label'             => esc_html__( 'Display Checkbox / Radio Inline?', 'divi-machine' ),
 'type'              => 'yes_no_button',
 'option_category'   => 'configuration',
 'options'           => array(
  'on'  => esc_html__( 'Yes', 'et_builder' ),
  'off' => esc_html__( 'No', 'et_builder' ),
 ),
 'default'   => 'off',
 'depends_show_if'   => 'radio',
 'description'       => esc_html__( 'Choose if you want the check boxes to be inline or on their own line', 'divi-machine' ),
),
'radio_all_text' => array(
'toggle_slug'       => 'radio_filter',
'label'             => esc_html__( 'All Label Text', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => 'All',
'depends_show_if'   => 'radio',
'description'       => esc_html__( 'Define the text you want shown as the "all" checkbox to show all the values.', 'divi-machine' ),
),
// 'radio_show_count' => array(
//     'toggle_slug'       => 'radio_filter',
//     'label'             => esc_html__( 'Display filter count?', 'divi-machine' ),
//     'type'              => 'yes_no_button',
//     'option_category'   => 'configuration',
//     'options'           => array(
//         'on'  => esc_html__( 'Yes', 'et_builder' ),
//         'off' => esc_html__( 'No', 'et_builder' ),
//     ),
//     'default'   => 'on',
//     'depends_show_if'   => 'radio',
//     'description'       => esc_html__( 'Choose if you want show filter count for every options.', 'divi-machine' ),
// ),
// 'radio_show_empty' => array(
//     'toggle_slug'       => 'radio_filter',
//     'label'             => esc_html__( 'Display empty filter option?', 'divi-machine' ),
//     'type'              => 'yes_no_button',
//     'option_category'   => 'configuration',
//     'options'           => array(
//         'on'  => esc_html__( 'Yes', 'et_builder' ),
//         'off' => esc_html__( 'No', 'et_builder' ),
//     ),
//     'default'   => 'off',
//     'depends_show_if'   => 'radio',
//     'description'       => esc_html__( 'Choose if you want show empty filter options.', 'divi-machine' ),
// ),
 'radio_button_background_color' => array(
   'label'             => esc_html__( 'Checkbox / Radio Button Background Color', 'et_builder' ),
   'type'              => 'color-alpha',
   'tab_slug'          => 'advanced',
   'depends_show_if'   => 'radio',
   'toggle_slug'       => 'filter_style',
   'description'       => esc_html__( 'This will change the fill color for the checkbox or radio button background.', 'et_builder' ),
   'default'           => "#ffffff"
 ),
   'radio_button_background_color_selected' => array(
     'label'             => esc_html__( 'Checkbox / Radio Button Background Color Selected', 'et_builder' ),
     'type'              => 'color-alpha',
     'tab_slug'          => 'advanced',
     'depends_show_if'   => 'radio',
     'toggle_slug'       => 'filter_style',
     'description'       => esc_html__( 'This will change the fill color for the checkbox or radio button background when selected/clicked.', 'et_builder' ),
     'default'           => $et_accent_color
   ),
     'radio_button_background_color_selected_text' => array(
       'label'             => esc_html__( 'Checkbox / Radio Button Font Color Selected', 'et_builder' ),
       'type'              => 'color-alpha',
       'tab_slug'          => 'advanced',
       'depends_show_if'   => 'radio',
       'toggle_slug'       => 'filter_style',
       'description'       => esc_html__( 'This will change the fill color for the checkbox or radio button text when selected/clicked.', 'et_builder' ),
       'default'           => '#ffffff'
     ),


     'tags_style' => array(
     'toggle_slug'       => 'tags_filter',
       'label'             => esc_html__( 'Category / Tags Appearance Style', 'divi-machine' ),
       'type'              => 'select',
       'options'           => array(
       'select'       => esc_html__( 'Select', 'divi-machine' ),
       'radio'       => esc_html__( 'Radio/Checkboxes', 'divi-machine' ),
       ),
       'option_category'   => 'configuration',
       'default'           => 'select',
       'description'       => esc_html__( 'Choose the appearance style of the slider', 'divi-machine' ),
     ),
// RANGE SETTINGS

// Number Range FILTER
// 'default_num' => array(
// 'toggle_slug'       => 'range_filter',
// 'label'             => esc_html__( 'Default Number', 'divi-machine' ),
// 'type'              => 'text',
// 'option_category'   => 'configuration',
// 'default'   => '3',
// 'depends_show_if'   => 'number_range',
// 'description'       => esc_html__( 'Choose the default image.', 'divi-machine' ),
// ),
// 'range_min' => array(
// 'toggle_slug'       => 'range_filter',
// 'label'             => esc_html__( 'Rumber Range Min', 'divi-machine' ),
// 'type'              => 'text',
// 'option_category'   => 'configuration',
// 'default'   => '1',
// 'depends_show_if'   => 'number_range',
// 'description'       => esc_html__( 'Add the min price for the slider.', 'divi-machine' ),
// ),

// 'range_type' => array(
// 'toggle_slug'       => 'range_filter',
//  'label'             => esc_html__( 'Range Type', 'divi-machine' ),
//  'type'              => 'select',
//  'options'           => array(
//  'single'       => esc_html__( 'Single', 'divi-machine' ),
//  'double'       => esc_html__( 'Double', 'divi-machine' ),
//  ),
//  'option_category'   => 'configuration',
//  'default'           => 'single',
//  'affects'         => array(
//    'range_from',
//    'range_to'
//  ),
//  'depends_show_if'   => 'number_range',
//  'description'       => esc_html__( 'Choose the type of range filter you want', 'divi-machine' ),
// ),
'range_from' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Range From Number', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => '100',
'depends_show_if'   => 'double',
'description'       => esc_html__( 'Choose the default from number.', 'divi-machine' ),
),
'range_to' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Range To Number', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => '800',
'depends_show_if'   => 'double',
'description'       => esc_html__( 'Choose the default to number.', 'divi-machine' ),
),
'range_step' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Number / Range Step', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => '1',
'depends_show_if'   => 'number_range',
'description'       => esc_html__( 'Choose the number it steps up.', 'divi-machine' ),
),
'range_skin' => array(
'toggle_slug'       => 'range_filter',
 'label'             => esc_html__( 'Number / Range Appearance Style', 'divi-machine' ),
 'type'              => 'select',
 'options'           => array(
 'flat'       => esc_html__( 'Flat', 'divi-machine' ),
 'big'       => esc_html__( 'Big', 'divi-machine' ),
 'modern'       => esc_html__( 'Modern', 'divi-machine' ),
 'sharp'       => esc_html__( 'Sharp', 'divi-machine' ),
 'round'       => esc_html__( 'Round', 'divi-machine' ),
 'square'       => esc_html__( 'Square', 'divi-machine' ),
 ),
 'option_category'   => 'configuration',
 'default'           => 'flat',
 'depends_show_if'   => 'number_range',
 'description'       => esc_html__( 'Choose the appearance style of the slider', 'divi-machine' ),
),
  'range_prim_color' => array(
    'label'             => esc_html__( 'Range Primary Color', 'divi-bodyshop-woocommerce' ),
    'type'              => 'color-alpha',
    'custom_color'      => true,
    'default'	=> et_get_option( 'accent_color', '#2ea3f2' ),
    'toggle_slug'       => 'range_filter',
     'option_category'   => 'configuration',
     'depends_show_if'   => 'number_range',
  ),
    'range_sec_color' => array(
      'label'             => esc_html__( 'Range Secondary Color', 'divi-bodyshop-woocommerce' ),
      'type'              => 'color-alpha',
      'custom_color'      => true,
      'default'	=> '#efefef',
      'toggle_slug'       => 'range_filter',
       'option_category'   => 'configuration',
       'depends_show_if'   => 'number_range',
    ),
'range_hide_min_max' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Range Hide Min and Max Labels', 'divi-machine' ),
'type'              => 'yes_no_button',
'option_category'   => 'configuration',
'options'           => array(
 'on'  => esc_html__( 'Yes', 'et_builder' ),
 'off' => esc_html__( 'No', 'et_builder' ),
),
'default'   => 'off',
'depends_show_if'   => 'number_range'
),
'range_hide_from_to' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Range Hide From and To Labels', 'divi-machine' ),
'type'              => 'yes_no_button',
'option_category'   => 'configuration',
'options'           => array(
 'on'  => esc_html__( 'Yes', 'et_builder' ),
 'off' => esc_html__( 'No', 'et_builder' ),
),
'default'   => 'off',
'depends_show_if'   => 'number_range'
),
'range_prettify_enabled' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Number / Range Prettify', 'divi-machine' ),
'type'              => 'yes_no_button',
'option_category'   => 'configuration',
'options'           => array(
 'on'  => esc_html__( 'Yes', 'et_builder' ),
 'off' => esc_html__( 'No', 'et_builder' ),
),
'default'   => 'on',
'depends_show_if'   => 'number_range',
'description'       => esc_html__( 'Enable this if you want to pretify your text, improve readibility of long numbers. 10000000 → 10 000 000', 'divi-machine' ),
),
'range_prettify_separator' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Number / Range Prettify Separator', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => ' ',
'depends_show_if'   => 'number_range',
'description'       => esc_html__( 'Set up your own separator for long numbers. 10 000, 10.000, 10-000 etc.', 'divi-machine' ),
),
'range_prefix' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Number / Range Before Text', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => '',
'depends_show_if'   => 'number_range',
'description'       => esc_html__( 'Set the text for values. Will be set up right before the number: $100', 'divi-machine' ),
),
'range_postfix' => array(
'toggle_slug'       => 'range_filter',
'label'             => esc_html__( 'Number / Range After Text', 'divi-machine' ),
'type'              => 'text',
'option_category'   => 'configuration',
'default'   => '',
'depends_show_if'   => 'number_range',
'description'       => esc_html__( 'Set the text for values. Will be set up right after the number: 100k', 'divi-machine' ),
)
                     );

                     return $fields;
                 }





                 function render( $attrs, $content = null, $render_slug ) {

                   if (is_admin()) {
                       return;
                   }

                   include(DE_DMACH_PATH . '/titan-framework/titan-framework-embedder.php');
                   $titan = TitanFramework::getInstance( 'divi-machine' );
                   $enable_debug = $titan->getOption( 'enable_debug' );

                   $post_type_choose                         = $this->props['post_type_choose'];

                   $filter_post_type                         = $this->props['filter_post_type'];

                   $acf_name                         = $this->props['acf_name'];
                   $acf_filter_type                  = $this->props['acf_filter_type'];
                   $acf_filter_width                 = $this->props['acf_filter_width'];
                   $show_label                 = $this->props['show_label'];

                   $text_placeholder                 = $this->props['text_placeholder'];

                   $select_placeholder                         = $this->props['select_placeholder'];

                   // $default_num                         = $this->props['default_num'];

                   $radio_style                         = $this->props['radio_style'];
                   $radio_select                         = $this->props['radio_select'];
                   $radio_all_text                         = $this->props['radio_all_text'];


                   // $checkbox_color                         = $this->props['checkbox_color'];
                   $range_prim_color                         = $this->props['range_prim_color'];
                   $range_sec_color                         = $this->props['range_sec_color'];

                   $radio_button_background_color                         = $this->props['radio_button_background_color'];
                   $radio_button_background_color_selected                         = $this->props['radio_button_background_color_selected'];
                   $radio_button_background_color_selected_text                        = $this->props['radio_button_background_color_selected_text'];

                   // $range_type                         = $this->props['range_type'];
                   $range_from                         = $this->props['range_from'];
                   $range_to                         = $this->props['range_to'];
                   $range_step                         = $this->props['range_step'];
                   $range_skin                         = $this->props['range_skin'];
                   $range_hide_min_max                         = $this->props['range_hide_min_max'];
                   $range_hide_from_to                         = $this->props['range_hide_from_to'];
                   $range_prettify_enabled                         = $this->props['range_prettify_enabled'];
                   $range_prettify_separator                         = $this->props['range_prettify_separator'];
                   $range_prefix                         = $this->props['range_prefix'];
                   $range_postfix                         = $this->props['range_postfix'];

                   $select_options                         = $this->props['select_options'];

                   $custom_label                         = $this->props['custom_label'];
                   $tags_style                         = $this->props['tags_style'];

                    $radio_inline                         = $this->props['radio_inline'];

                    $radio_show_count                     = $this->props['radio_show_count'];
                    $radio_show_empty                    = $this->props['radio_show_empty'];

                    if ($radio_inline == "on") {
                        $this->add_classname( 'inline_checkboxes');
                    }

                   $num = mt_rand(100000,999999);
                   $css_class              = $render_slug . "_" . $num;


                   if ($range_hide_min_max == "off") {$range_hide_min_max = "false";} else {$range_hide_min_max = "true";};
                   if ($range_hide_from_to == "off") {$range_hide_from_to = "false";} else {$range_hide_from_to = "true";};
                   if ($range_prettify_enabled == "off") {$range_prettify_enabled = "false";} else {$range_prettify_enabled = "true";};

                     $this->add_classname( array(
                       $acf_filter_width,
                       'et_pb_column',
                     ) );




                   if ( ! empty( $radio_button_background_color ) ) {
                     self::set_style( $render_slug,
                       array(
                         'selector'    => '%%order_class%% .dmach-radio-buttons .et_pb_contact_field_radio label',
                         'declaration' => sprintf( 'background-color: %1$s;', esc_attr( $radio_button_background_color ) ),
                       ) );
                   }
                   // TODO: add color for simple radiio
                   if ( ! empty( $radio_button_background_color_selected ) ) {
                     self::set_style( $render_slug,
                       array(
                         'selector'    => '%%order_class%% .dmach-radio-buttons .et_pb_contact_field_radio input:checked+label, %%order_class%% .dmach-radio-tick_box input:checked ~ .checkmark',
                         'declaration' => sprintf( 'background-color: %1$s;', esc_attr( $radio_button_background_color_selected ) ),
                       ) );
                   }


if ($show_label == "off") {
$label_css = "dmach-hide";
} else {
$label_css = "";
}

if ($acf_filter_width == "et_pb_column_4_4") {
  $acf_filter_width_num = "100";
} else if ($acf_filter_width == "et_pb_column_3_4") {
  $acf_filter_width_num = "75";
} else if ($acf_filter_width == "et_pb_column_2_3") {
  $acf_filter_width_num = "60";
} else if ($acf_filter_width == "et_pb_column_1_2") {
  $acf_filter_width_num = "50";
} else if ($acf_filter_width == "et_pb_column_1_3") {
  $acf_filter_width_num = "40";
} else if ($acf_filter_width == "et_pb_column_1_4") {
  $acf_filter_width_num = "25";
} else {

}









                 //////////////////////////////////////////////////////////////////////

                   ob_start();

                   if ($enable_debug == "1") {
                   $acf_get = get_field_object($acf_name);
                     ?>
                     <div class="reporting_args hidethis">
                       Post Type: <?php echo esc_html__($post_type_choose); ?><br>
                       Filter Post Type: <?php echo esc_html__($filter_post_type); ?><br>
                       ACF Name: <?php echo esc_html__($acf_name); ?><br>
                       ACF Filter Type: <?php echo esc_html__($acf_filter_type); ?><br>
                       Show Label: <?php echo esc_html__($show_label); ?><br><br>
                       ACF Data: <br>
                       <?php print_r($acf_get); ?>
                     </div>
                     <?php
                   }


?> <div class="search_filter_cont hidden <?php echo $css_class ?>" data-count="<?php echo $acf_filter_width_num ?>"> <?php


                   if ($filter_post_type == "category") {


                     if ($custom_label !== '') {
                       $custom_label_final = $custom_label;
                     } else {
                       $custom_label_final = 'Categories';
                     }

                     if ($post_type_choose == 'post') {
                     $cat_key = 'category';
                     $get_categories = get_categories();
                     } else {
                     $ending = "_category";
                     $cat_key = $post_type_choose . $ending;
                     $get_categories = get_terms( $cat_key, array('hide_empty' => false) );
                   }


                   $queryvar = get_query_var( $cat_key )?get_query_var( $cat_key):( !empty($_GET[$cat_key])?$_GET[$cat_key]:'' );


if ($tags_style == "select") {
                       ?>
                     <p class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></p>
                       <p class="et_pb_contact_field dmach-filter-item" data-type="select" name="categories" data-field_type="select">

                             <select id="<?php echo $cat_key ?>" class="dmach-acf et_pb_contact_select" data-filtertype="customcategory" name="<?php echo $cat_key ?>">
                                 <option value="" <?php selected( $queryvar, ''); ?>><?php echo $select_placeholder ?></option>
                                 <?php
                           if ( $get_categories ) :
                             foreach ( $get_categories as $cat ) :

                           ?>
                               <option id="<?php echo $cat->term_id; ?>" value="<?php echo $cat->slug; ?>" <?php selected( $queryvar, $cat->slug); ?>>
                                   <?php echo $cat->name; ?>
                               </option>
                           <?php endforeach;
                             endif;
                           ?>
                             </select>
                       </p>
                       <?php
} else {

  if ($radio_select == "checkbox") {
   $checkboxtype = "dmach-checkboxmulti";
  } else {
    $checkboxtype = "dmach-checkboxsingle";
  }

  ?>

  <p class="et_pb_contact_field" data-type="radio">
  <div class="et_pb_contact_field_options_wrapper dmach-radio-<?php echo $radio_style ?>">
  <span class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></span>
  <div class="et_pb_contact_field_options_list dmach-filter-item <?php echo $checkboxtype ?>" data-filter-count="<?php echo $radio_show_count;?>" data-show-empty="<?php echo $radio_show_empty;?>">

  <span class="et_pb_contact_field_radio">
  <input type="<?php echo $radio_select ?>" id="all" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="" name="tags" data-required_mark="required" data-field_type="radio" data-original_id="radio" checked="checked">
  <?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
  <label class="radio-label" data-value="all" for="all"><i></i><?php echo esc_html__( $radio_all_text, 'divi-machine' ); ?></label>
  </span>

  <?php
  if ( $get_categories ) :
   foreach ( $get_categories as $cat ) :
   ?>
  <span class="et_pb_contact_field_radio">


  <input type="<?php echo $radio_select ?>" id="<?php echo $cat->term_id; ?>_<?php echo $cat->slug ?>" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="<?php echo $cat->slug ?>" name="tags" data-required_mark="required" data-field_type="radio" data-original_id="radio">
  <?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
  <label class="radio-label" data-value="<?php echo $cat->slug ?>" for="<?php echo $cat->slug ?>"><i></i><?php echo $cat->name; ?></label>

  </span>
  <?php

  endforeach;
  endif;

  ?>

  </div>
  </div>
  </p>

   <?php
}

                   } else if ($filter_post_type == "acf") {
                   $acf_get = get_field_object($acf_name);
                   $acf_type = $acf_get['type'];


                   $queryvar = get_query_var($acf_get['name']) ? get_query_var($acf_get['name']) : ( !empty( $_GET[$acf_get['name']] )? $_GET[$acf_get['name']] : '' );

                     if ($custom_label !== '') {
                       $custom_label_final = $custom_label;
                     } else {
                       $custom_label_final = $acf_get['label'];
                     }

                   ?> <div class="et_pb_contact"> <?php

                    if ($acf_filter_type == "select") {

                     if ($acf_type == "select" || $acf_type == "checkbox") {

                       if ($acf_type == "select") {
                         $acf_type_filter = "acfselect";
                       } else {
                         if ($radio_select == "checkbox") {
                           $acf_type_filter = "dmach-checkboxmulti";
                          } else {
                            $acf_type_filter = "dmach-checkboxsingle";
                          }
                       }
                     ?>
<p class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></p>
                     <p class="et_pb_contact_field dmach-filter-item" data-type="select">
                     <select id="<?php echo $acf_get['name']; ?>" class="dmach-acf et_pb_contact_select" data-filtertype="<?php echo $acf_type_filter ?>" name="<?php echo $acf_get['name']; ?>" data-field_type="select">
                     <option value="" selected="selected"><?php echo $select_placeholder ?></option>
                     <?php
                     foreach($acf_get['choices'] as $key => $value) {
                       if ($queryvar == $key) {
                     ?>
                     <option value="<?php echo $key ?>" selected="selected"><?php echo $value; ?></option>
                     <?php
                       } else {
                     ?>
                     <option value="<?php echo $key ?>"><?php echo $value; ?></option>
                     <?php
                   }
                     }
                     ?>
                     </select>
                     </p>
                     <?php
                     } else {
                       echo "Please make sure your field is a select or checkbox type";
                   }
                   }
                   else if ($acf_filter_type == "radio") {

                  if ($radio_style == "select") {
                    ?>                   <p class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></p>
                                         <p class="et_pb_contact_field dmach-filter-item" data-type="select" name="<?php echo $acf_get['name']; ?>" data-field_type="select">
                        <select id="<?php echo $acf_get['name']; ?>" class="dmach-acf et_pb_contact_select" data-filtertype="dmach-checkboxsingle" name="<?php echo $acf_get['name']; ?>">
                            <option value="" selected="selected"><?php echo $select_placeholder ?></option>
                            <?php
              foreach($acf_get['choices'] as $key => $value) {

                if ($queryvar == $key) {
              ?>
              <option id="<?php echo $acf_get['name']; ?>_<?php echo $key ?>" value="<?php echo $key ?>" selected="selected"><?php echo $value; ?></option>
              <?php
                } else {
                      ?>
                <option id="<?php echo $acf_get['name']; ?>_<?php echo $key ?>" value="<?php echo $key ?>"><?php echo $value; ?></option>
                              <?php
                            }
                          }
                      ?>
                        </select>
                      </p>
<?php
                  } else {

                     if ($radio_select == "checkbox") {
                       $checkboxtype = "dmach-checkboxmulti";
                      } else {
                        $checkboxtype = "dmach-checkboxsingle";
                      }

                      $additional_classes = '';
                      if ( isset( $radio_show_count ) && $radio_show_count == 'on' ){
                        $additional_classes .= ' dmach-show-count';
                      }

                      if ( isset( $radio_show_count ) && $radio_show_count == 'on' ){
                        $additional_classes .= ' dmach-show-empty';
                      }

                     ?>

                     <p class="et_pb_contact_field" data-type="radio">
                     <div class="et_pb_contact_field_options_wrapper dmach-radio-<?php echo $radio_style ?>">
<span class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></span>
           <div class="et_pb_contact_field_options_list dmach-filter-item <?php echo $checkboxtype ?>" data-filter-count="<?php echo $radio_show_count;?>" data-show-empty="<?php echo $radio_show_empty;?>">

             <span class="et_pb_contact_field_radio">
             <input type="<?php echo $radio_select ?>" id="all" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="" name="<?php echo $acf_get['name']; ?>" data-required_mark="required" data-field_type="radio" data-original_id="radio" checked="checked">
             <?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
             <label class="radio-label" data-value="all" for="all"><i></i><?php echo esc_html__( $radio_all_text, 'divi-machine' ); ?></label>
             </span>

             <?php foreach($acf_get['choices'] as $key => $value) { ?>
             <span class="et_pb_contact_field_radio">
               <?php
                 if ($queryvar == $key) {
               ?>
               <input type="<?php echo $radio_select ?>" id="<?php echo $acf_get['name']; ?>_<?php echo $key ?>" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="<?php echo $key ?>" name="<?php echo $acf_get['name']; ?>" data-required_mark="required" data-field_type="radio" data-original_id="radio" checked="checked">
               <?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
               <label class="radio-label" data-value="<?php echo $key ?>" for="<?php echo $key ?>"><i></i><?php echo $value; ?></label>
               <?php
                 } else {
               ?>
               <input type="<?php echo $radio_select ?>" id="<?php echo $acf_get['name']; ?>_<?php echo $key ?>" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="<?php echo $key ?>" name="<?php echo $acf_get['name']; ?>" data-required_mark="required" data-field_type="radio" data-original_id="radio">
               <?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
               <label class="radio-label" data-value="<?php echo $key ?>" for="<?php echo $key ?>"><i></i><?php echo $value; ?></label>
             <?php } ?>
             </span>
           <?php } ?>

         </div>
       </div>
       </p>
      <?php
    }
                   } else if ($acf_filter_type == "number_range") {

                     $acf_type = $acf_get['type'];

                     if ($acf_type == "range") {
                       $range_type = "double";
                     } else if ($acf_type == "number")  {
                       $range_type = "single";
                     } else {
                       $range_type = "none";
                     }

 if ($range_type == "none") {
   echo "please make sure your ACF item is a number or a range field.";
 } else {

                       if (isset($queryvar)) {
                           $queryvar_arr = (explode(";",$queryvar));
                           if ( is_array( $queryvar_arr ) ) {
                               if ( isset( $queryvar_arr[1] ) ){
                                   $range_from_query = $queryvar_arr[0];
                                   $range_to_query = $queryvar_arr[1];
                               }else{
                                   $range_from_query = $queryvar_arr[0];
                                   $range_to_query = '';
                               }
                           } else {
                               $range_from_query = "";
                               $range_to_query = "";
                           }
                       }

                       if ($range_from_query != "") {
                           $range_from = $range_from_query;
                       }
                       if ($range_to_query != "") {
                           $range_to = $range_to_query;
                       }


if ($acf_get['max'] < $range_to) {
 $range_to = $acf_get['max'];
}
           ?>


                     <p class="et_pb_contact_field" data-type="range">
<span class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></span>

<div class="dmach-filter-item">
<input id="<?php echo $acf_get['name']; ?>" type="select" class="dmach-acf js-range-slider" data-filtertype="rangeslider" name="<?php echo $acf_get['name']; ?>" value="" />
</div>
                   </p>
<?php
$css_classrend = "." . $css_class . "";
 ?>
<style>
<?php echo $css_classrend ?> .irs-bar,
<?php echo $css_classrend ?> .irs-from,
<?php echo $css_classrend ?> .irs-to,
<?php echo $css_classrend ?> .irs-single,
<?php echo $css_classrend ?> .irs-handle>i:first-child {
 background-color: <?php echo $range_prim_color; ?> !important;
}
<?php echo $css_classrend ?> .irs-from:before,
<?php echo $css_classrend ?> .irs-to:before,
<?php echo $css_classrend ?> .irs-single:before {
 border-top-color: <?php echo $range_prim_color; ?> !important;
}
<?php echo $css_classrend ?> .irs-line,
<?php echo $css_classrend ?> .irs-min,
<?php echo $css_classrend ?> .irs-max {
 background-color: <?php echo $range_sec_color; ?> !important;
}
</style>

<?php
if ($acf_get['min'] == "") {
  $acf_get['min'] = "0";
}
?>

 <script>
 jQuery(document).ready(function($) {

   var type = '<?php echo $range_type ?>',
   min = <?php echo $acf_get['min'] ?>,
   max = <?php echo $acf_get['max'] ?>,
   from = <?php echo $range_from ?>,
   to = <?php echo $range_to ?>,
   step = <?php echo $range_step ?>,
   skin = "<?php echo $range_skin ?>",
   hide_min_max = <?php echo $range_hide_min_max ?>,
   hide_from_to = <?php echo $range_hide_from_to ?>,
   prettify_enabled = <?php echo $range_prettify_enabled ?>,
   prettify_separator = "<?php echo $range_prettify_separator ?>",
   prefix = "<?php echo $range_prefix ?>"  // before the number
   postfix = "<?php echo $range_postfix ?>"; // after the number

   var filters = [];

   var filter_item_name_arr = [];
   var filter_item_id_arr = [];
   var filter_item_val_arr = [];
   var filter_input_type_arr = [];
   jQuery('.dmach-acf').each(function(i, obj) {
   var filter_item_name = jQuery(this).attr("name"),
       filter_item_id = jQuery(this).attr("id"),
       filter_item_val = jQuery(this).val(),
       filter_input_type = jQuery(this).attr('type');
   filter_item_name_arr.push(filter_item_name);
   filter_item_id_arr.push(filter_item_id);
   filter_item_val_arr.push(filter_item_val);
   filter_input_type_arr.push(filter_input_type);
   });

   var filter_item_name = jQuery(".<?php echo $css_class ?> .js-range-slider").attr("name");

   $(".<?php echo $css_class ?> .js-range-slider").ionRangeSlider({
     type: type,
      min: min,
      max: max,
      from: from,
      to: to,
      step: step,
      skin: skin,
      hide_min_max: hide_min_max,
      hide_from_to: hide_from_to,
      prettify_enabled: prettify_enabled,
      prettify_separator: prettify_separator,
      prefix: prefix,
      postfix: postfix,
      onFinish: function (data) {
           if ( $(".<?php echo $css_class ?> .js-range-slider").parents('.et_pb_de_mach_search_posts').length == 0 &&
               $(".<?php echo $css_class ?> .js-range-slider").parents('.updatetype-update_button').length == 0 ){
               dmach_find_filters_to_filter();
           }
       }
    });

});
 </script>
                     <?php
                   }

}

                   ?> </div> <?php

                 } else if ($filter_post_type == "tags") {



                     if ($custom_label !== '') {
                       $custom_label_final = $custom_label;
                     } else {
                       $custom_label_final = 'Tags';
                     }


                       $ending = "_tag";
                       $cat_key = $post_type_choose . $ending;

                       $get_categories = get_terms( $cat_key, array('hide_empty' => false) );

                       $queryvar = get_query_var( $cat_key )?get_query_var( $cat_key):( !empty($_GET[$cat_key])?$_GET[$cat_key]:'' );


if ($tags_style == "select") {
                       ?>                   <p class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></p>
                                            <p class="et_pb_contact_field dmach-filter-item" data-type="select" name="tags" data-field_type="select">
                           <select id="<?php echo $cat_key ?>" class="dmach-acf et_pb_contact_select" data-filtertype="customtag" name="<?php echo $cat_key ?>">
                               <option value="" selected="selected"><?php echo $select_placeholder ?></option>
                               <?php
                         if ( $get_categories ) :
                           foreach ( $get_categories as $cat ) :

                         ?>
                                   <option id="<?php echo $cat->term_id; ?>" value="<?php echo $cat->slug; ?>">
                                       <?php echo $cat->name; ?>
                                   </option>
                                   <?php endforeach;
                           endif;
                         ?>
                           </select>
                         </p>
<?php
} else {


if ($radio_select == "checkbox") {
 $checkboxtype = "dmach-checkboxmulti";
} else {
  $checkboxtype = "dmach-checkboxsingle";
}

?>

<p class="et_pb_contact_field" data-type="radio">
<div class="et_pb_contact_field_options_wrapper dmach-radio-<?php echo $radio_style ?>">
<span class="et_pb_contact_field_options_title <?php echo $label_css ?>"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></span>
<div class="et_pb_contact_field_options_list dmach-filter-item <?php echo $checkboxtype ?>">

<span class="et_pb_contact_field_radio">
<input type="<?php echo $radio_select ?>" id="all" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="" name="tags" data-required_mark="required" data-field_type="radio" data-original_id="radio" checked="checked">
<?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
<label class="radio-label" data-value="all" for="all"><i></i><?php echo esc_html__( $radio_all_text, 'divi-machine' ); ?></label>
</span>

<?php
if ( $get_categories ) :
 foreach ( $get_categories as $cat ) :
 ?>
<span class="et_pb_contact_field_radio">


<input type="<?php echo $radio_select ?>" id="<?php echo $cat->term_id; ?>_<?php echo $cat->slug ?>" class="dmach-acf input" data-filtertype="<?php echo $checkboxtype ?>" value="<?php echo $cat->slug ?>" name="tags" data-required_mark="required" data-field_type="radio" data-original_id="radio">
<?php if ($radio_style == "tick_box") { echo '<span class="checkmark"></span>'; } else {} ?>
<label class="radio-label" data-value="<?php echo $cat->slug ?>" for="<?php echo $cat->slug ?>"><i></i><?php echo $cat->name; ?></label>

</span>
<?php

endforeach;
endif;

?>

</div>
</div>
</p>

<?php

}
?>

                     </p>
                     <?php
                 } else if ($filter_post_type == "search") {

                   if ($custom_label !== '') {
                     $custom_label_final = $custom_label;
                   } else {
                     $custom_label_final = '';
                   }

                   if (get_search_query() == "") {
                     $seach_value = get_search_query();
                   } else {
                     $seach_value = "";
                   }

                     ?>

                     <p class="et_pb_contact_field" data-type="input" style="padding-left: 0;">
                       <span class="et_pb_contact_field_options_title"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></span>
                     <input id="s" class="dmach-acf dmach-filter-item" data-filtertype="textsearch" type="text" name="s" placeholder="<?php echo esc_html__( $text_placeholder, 'divi-machine' ); ?>" value="<?php echo $seach_value ?>" style="width: 100%;">
                     </p>

                     <?php

                 } else if ($filter_post_type == "posttypes") {

                   if ($custom_label !== '') {
                     $custom_label_final = $custom_label;
                   } else {
                     $custom_label_final = '';
                   }


                   $option_search  = array( '&#91;', '&#93;' );
                   $option_replace = array( '[', ']' );
                   $select_options = str_replace( $option_search, $option_replace, $select_options );
                   $select_options = json_decode( $select_options );


?>
<p class="et_pb_contact_field_options_title"><?php echo esc_html__( $custom_label_final, 'divi-machine' ); ?></p>
                     <p class="et_pb_contact_field dmach-filter-item" data-type="select">
                     <select id="select_post_types" class="dmach-acf et_pb_contact_select" data-filtertype="posttypes" name="select_post_types" data-field_type="select">
                     <option value="" selected="selected"><?php echo $select_placeholder ?></option>
                     <?php
                     foreach ( $select_options as $option ) {
                       $pt = get_post_type_object( $option->value );
                     ?>
                     <option value="<?php echo $option->value; ?>"><?php echo $pt->labels->name; ?></option>
                     <?php
                   }

                     ?>
                     </select>
                     </p>
<?php


} else if ($filter_post_type == "sort") {



} else if ($filter_post_type == "date") {



                  }  else {

                 }

                ?>
               </div>
               <?php

                   $data = ob_get_clean();

                  //////////////////////////////////////////////////////////////////////

                 return $data;

             }

           }

           new de_mach_search_posts_item_code;

?>
