<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class de_mach_thumbnail_code extends ET_Builder_Module {

public $vb_support = 'on';

protected $module_credits = array(
  'module_uri' => DE_DMACH_PRODUCT_URL,
  'author'     => DE_DMACH_AUTHOR,
  'author_uri' => DE_DMACH_URL,
);

                function init() {
                    $this->name       = esc_html__( '.Thumbnail - Divi Machine', 'divi-machine' );
                    $this->slug = 'et_pb_de_mach_thumbnail';


                    $this->fields_defaults = array(
                    // 'loop_layout'         => array( 'on' ),
                    );

          $this->settings_modal_toggles = array(
      			'general' => array(
      				'toggles' => array(
      					'main_content' => esc_html__( 'Main Options', 'divi-machine' ),
      				),
      			),
      			'advanced' => array(
      				'toggles' => array(
      					'text' => esc_html__( 'Text', 'divi-machine' ),
      				),
      			),

      		);


                      $this->main_css_element = '%%order_class%%';


                      $this->advanced_fields = array(
                  			'fonts' => array(
                  				'title' => array(
                  					'label'    => esc_html__( 'Title', 'divi-machine' ),
                  					'css'      => array(
                  						'main' => "%%order_class%% .dmach-post-title",
                  						'important' => 'plugin_only',
                  					),
                  					'font_size' => array(
                  						'default' => '14px',
                  					),
                  					'line_height' => array(
                  						'default' => '1em',
                  					),
                  				),
                  			),
              			'background' => array(
              				'settings' => array(
              					'color' => 'alpha',
              				),
              			),
                  			'button' => array(
                  			),
                  			'box_shadow' => array(
                  				'default' => array(),
                  				'product' => array(
                  					'label' => esc_html__( 'Default Layout - Box Shadow', 'divi-machine' ),
                  					'css' => array(
                  						'main' => "%%order_class%% .products .product",
                  					),
                  					'option_category' => 'layout',
                  					'tab_slug'        => 'advanced',
                  					'toggle_slug'     => 'product',
                  				),
                  			),
                  		);


                      $this->custom_css_fields = array(
                  		);


            $this->help_videos = array(
            );
          }

                  function get_fields() {
                    $options = $col_options = array();
                    $sizes = get_intermediate_image_sizes();

                    foreach ($sizes as $size) {
                        $options[$size] = $size;
                    }

                    for ($i = 1; $i <= 6; $i++) {
                        $col_options[$i] = $i;
                    }


                    $acf_fields = DEDMACH_INIT::get_acf_fields();


                      $fields = array(
                        'thumb_image_size' => array(
                            'label' => __('Thumbnail Image Size', 'et_builder'),
                            'type' => 'select',
                            'computed_affects' => array(
                              '__getthumbnail',
                            ),
                            'options' => $options,
                            'default' => 'woocommerce_thumbnail',
                            'description' => __('Pick a size for the thumbnail image from the list. This will only work on the no overlay and flip image options.', 'et_builder'),
                        ),
                                    'link_product' => array(
                                    'label'             => esc_html__( 'Link Image to Single Page', 'et_builder' ),
                                    'type'              => 'yes_no_button',
                                    'option_category'   => 'configuration',
                                    'options'           => array(
                                    'on'  => esc_html__( 'Yes', 'et_builder' ),
                                    'off' => esc_html__( 'No', 'et_builder' ),
                                    ),
                                    'description'        => esc_html__( 'Enable this if you want to allow the user to click on the image to go to the product page.)', 'et_builder' ),
                                    ),

                                    'image_style' => array(
                                      'label'             => esc_html__( 'Image Style', 'et_builder' ),
                                      'type'              => 'select',
                                      // 'option_category'   => 'color_option',
                                      'options'           => array(
                                        'default'  => esc_html__( 'Default', 'et_builder' ),
                                        'no_overlay' => esc_html__( 'Image Only (no overlay)', 'et_builder' ),
                                        'flip_image'  => esc_html__( 'Flip Image', 'et_builder' ),
                                      ),
                              				'affects'         => array(
                                					'acf_name',
                                          'return_format'
                              				),
                                      'description'       => esc_html__( 'Choose what style of thumbnail you want, for example if you want the first image of your gallery to flip to when hovering over the thumbnail, select "Flip Hover".', 'et_builder' ),
                                    ),

                                    'acf_name' => array(
                                      'label'             => esc_html__( 'Choose Second Image', 'divi-machine' ),
                                      'type'              => 'select',
                              				'depends_show_if'   => 'flip_image',
                                      'options'           => $acf_fields,
                                      'option_category'   => 'configuration',
                                      'description'       => esc_html__( 'Choose the second image you want to show when hovered (flip)', 'divi-machine' ),
                                    ),

                                                          'return_format' => array(
                                                          'option_category'   => 'configuration',
                                                  				'depends_show_if'   => 'flip_image',
                                                            'label'             => esc_html__( 'Image Return Format', 'divi-machine' ),
                                                            'type'              => 'select',
                                                            'options'           => array(
                                                              'array' => esc_html__( 'Array', 'divi-machine' ),
                                                              'url' => sprintf( esc_html__( 'URL', 'divi-machine' ) ),
                                                              'id' => sprintf( esc_html__( 'ID', 'divi-machine' ) ),
                                                            ),
                                                            'default' => 'array',
                                                            'description'       => esc_html__( 'Choose how you have defined the return format in ACF settings.', 'divi-machine' ),
                                                          ),
                                    'icon_hover_color' => array(
                                      'label'             => esc_html__( 'Icon Hover Color', 'et_builder' ),
                                      'type'              => 'color-alpha',
                                      'custom_color'      => true,
                                      'tab_slug'          => 'advanced',
                                      'toggle_slug'       => 'overlay',
                                    ),
                                    'hover_overlay_color' => array(
                                      'label'             => esc_html__( 'Hover Overlay Color', 'et_builder' ),
                                      'type'              => 'color-alpha',
                                      'custom_color'      => true,
                                      'tab_slug'          => 'advanced',
                                      'toggle_slug'       => 'overlay',
                                    ),
                                    'hover_icon' => array(
            				'label'               => esc_html__( 'Hover Icon Picker', 'et_builder' ),
            				'type'                => 'select_icon',
            				'option_category'     => 'configuration',
            				'default'			=> 'P',
            				'class'               => array( 'et-pb-font-icon' ),
            				'depends_show_if'     => 'on',
            				'tab_slug'            => 'advanced',
            				'toggle_slug'         => 'overlay',
            				'description'         => esc_html__( 'Here you can define a custom icon for the overlay', 'et_builder' ),
            			),
                  'align' => array(
            				'label'           => esc_html__( 'Image Alignment', 'et_builder' ),
            				'type'            => 'text_align',
            				'option_category' => 'layout',
            				'options'         => et_builder_get_text_orientation_options( array( 'justified' ) ),
            				'default_on_front' => 'left',
            				'tab_slug'        => 'advanced',
            				'toggle_slug'     => 'alignment',
            				'description'     => esc_html__( 'Here you can choose the image alignment.', 'et_builder' ),
            				'options_icon'    => 'module_align',
            			),
            			'force_fullwidth' => array(
            				'label'             => esc_html__( 'Force Fullwidth', 'et_builder' ),
            				'type'              => 'yes_no_button',
            				'option_category'   => 'layout',
            				'options'           => array(
            					'off' => esc_html__( 'No', 'et_builder' ),
            					'on'  => esc_html__( 'Yes', 'et_builder' ),
            				),
            				'default_on_front' => 'off',
            				'tab_slug'    => 'advanced',
            				'toggle_slug' => 'width',
            				'affects' => array(
            					'max_width',
            				),
            			),
            			'always_center_on_mobile' => array(
            				'label'             => esc_html__( 'Always Center Image On Mobile', 'et_builder' ),
            				'type'              => 'yes_no_button',
            				'option_category'   => 'layout',
            				'options'           => array(
            					'on'  => esc_html__( 'Yes', 'et_builder' ),
            					'off' => esc_html__( 'No', 'et_builder' ),
            				),
            				'default_on_front' => 'on',
            				'tab_slug'          => 'advanced',
            				'toggle_slug'       => 'alignment',
            			),
                    '__getthumbnail' => array(
                        'type' => 'computed',
                        'computed_callback' => array( 'de_mach_thumbnail_code', 'get_thumbnail' ),
                        'computed_depends_on' => array(
                          'thumb_image_size',
                        ),
                    ),
                    );

                    return $fields;
                }

                public static function get_thumbnail ( $args = array(), $conditional_tags = array(), $current_page = array() ){
                  if (!is_admin()) {
                    return;
                  }

                  $thumb_image_size  = $args['thumb_image_size'];


                    ob_start();

                    $post_slug = DEDMACH_INIT::get_vb_post_type();

                    $get_cpt_args = array(
                      'post_type' => $post_slug,
                      'post_status' => 'publish',
                      'posts_per_page' => '1',
                      'orderby' => 'ID',
                      'order' => 'ASC',
                  );

                  query_posts( $get_cpt_args );

                  $first = true;

                  if ( have_posts() ) {
                    while ( have_posts() ) {
                      the_post();
                      // setup_postdata( $post );

                    if ( $first )  {

                //////////////////////////////////////////////////

                echo get_the_post_thumbnail( get_the_id(), $thumb_image_size, array( 'class' => 'featured-image' ) );

                //////////////////////////////////////////////////
                  $first = false;
                    } else {

                    }

                }
                }

                    $data = ob_get_clean();

                  return $data;

                  }



                  function render( $attrs, $content = null, $render_slug ) {

                    $link_product      = $this->props['link_product'];
                    $image_style     = $this->props['image_style'];
                    $align                   = $this->get_alignment();
                    $force_fullwidth         = $this->props['force_fullwidth'];
                    $always_center_on_mobile = $this->props['always_center_on_mobile'];
                    $icon_hover_color     = $this->props['icon_hover_color'];
                    $hover_overlay_color     = $this->props['hover_overlay_color'];
                    $hover_icon              = $this->props['hover_icon'];
                    $animation_style         = $this->props['animation_style'];
                    $thumb_image_size         = $this->props['thumb_image_size'];
                    $acf_name         = $this->props['acf_name'];
                    $return_format                   = $this->props['return_format'];

                    if ( '' !== $icon_hover_color ) {
                      ET_Builder_Element::set_style( $render_slug, array(
                        'selector'    => '%%order_class%% .et_overlay:before',
                        'declaration' => sprintf(
                          'color: %1$s !important;',
                          esc_html( $icon_hover_color )
                        ),
                      ) );
                    }

                    if ( '' !== $hover_overlay_color ) {
                      ET_Builder_Element::set_style( $render_slug, array(
                        'selector'    => '%%order_class%% .et_overlay',
                        'declaration' => sprintf(
                          'background-color: %1$s !important;
                          border-color: %1$s;',
                          esc_html( $hover_overlay_color )
                        ),
                      ) );
                    }

if ( ! $this->_is_field_default( 'align', $align ) ) {
ET_Builder_Element::set_style( $render_slug, array(
'selector'    => '%%order_class%%',
'declaration' => sprintf(
'text-align: %1$s;',
esc_html( $align )
),
) );
}

if ( 'center' !== $align ) {
ET_Builder_Element::set_style( $render_slug, array(
'selector'    => '%%order_class%%',
'declaration' => sprintf(
'margin-%1$s: 0;',
esc_html( $align )
),
) );
}

if ( 'on' === $force_fullwidth ) {
ET_Builder_Element::set_style( $render_slug, array(
'selector'    => '%%order_class%%',
'declaration' => 'max-width: 100% !important;',
) );

ET_Builder_Element::set_style( $render_slug, array(
'selector'    => '%%order_class%% .et_pb_image_wrap, %%order_class%% img',
'declaration' => 'width: 100%;',
) );
}

if ( 'on' === $always_center_on_mobile ) {
$this->add_classname( 'et_always_center_on_mobile' );
}


if ($image_style == "flip_image"){
$this->add_classname( 'flip-image-thumbnail' );
}

if ( ! in_array( $animation_style, array( '', 'none' ) ) ) {
$this->add_classname( 'et-waypoint' );
}



if ( '' !== $hover_overlay_color ) {
ET_Builder_Element::set_style( $render_slug, array(
'selector'    => '%%order_class%% .et_overlay',
'declaration' => sprintf(
'background-color: %1$s;',
esc_html( $hover_overlay_color )
),
) );
}


$css_icon_hover = DEDMACH_INIT::et_icon_css_content( esc_attr($hover_icon) );

ET_Builder_Element::set_style( $render_slug, array(
'selector'    => '%%order_class%% .et_overlay:before',
'declaration' => sprintf(
'content: "%1$s";',
esc_html( $css_icon_hover )
),
) );

                  //////////////////////////////////////////////////////////////////////

                    ob_start();

                    $post   = get_post( get_the_id() );


                    if ($link_product == 'on') {

                    $url = get_permalink( get_the_id() );
                    echo '<a href="'.$url.'" >';
                  }

                  if ($image_style == "flip_image"){


                    $acf_get = get_field_object($acf_name);
                    $acf_type = $acf_get['type'];
                    $image = get_field($acf_name);

                    if ($acf_type == "image") {

                      if ($return_format == "array") {
                        $thumb = esc_url($image['url']);
                        $alt = esc_attr($image['alt']);

                      } else if ($return_format == "id") {

                        $thumb = wp_get_attachment_image( $image, $thumb_image_size );
                        $alt = "";

                      }

                    ?>
                    <img class="secondary-image" src="<?php echo $thumb ?>" alt="<?php echo $alt ?>" />
                    <?php

                    echo get_the_post_thumbnail( get_the_id(), $thumb_image_size, array( 'class' => 'featured-image' ) );



                } else {
                }

                  }
                  else if ($image_style == "no_overlay") {

                    echo get_the_post_thumbnail( get_the_id(), $thumb_image_size, array( 'class' => 'featured-image' ) );


                  }
                  else {
?>
<span class="et_shop_image">
<?php
echo get_the_post_thumbnail( get_the_id(), $thumb_image_size, array( 'class' => 'featured-image' ) );
?>
<span class="et_overlay"></span>
</span>
<?php
                  }


                    if ($link_product == 'on') {
                    echo '</a>';
                    }




                    $data = ob_get_clean();



                   //////////////////////////////////////////////////////////////////////

                  return $data;



              }

            }

            new de_mach_thumbnail_code;

?>
