<?php
if ( ! defined( 'ABSPATH' ) ) exit;

class de_mach_view_button_code extends ET_Builder_Module {

  public static $button_text, $p;
	public static function change_button_text( $btn_text ){
		if( !empty( self::$button_text ) ){
			$btn_text = esc_html__( self::$button_text );
		}
		return $btn_text;
	}

public $vb_support = 'on';

protected $module_credits = array(
  'module_uri' => DE_DMACH_PRODUCT_URL,
  'author'     => DE_DMACH_AUTHOR,
  'author_uri' => DE_DMACH_URL,
);

                function init() {
                    $this->name       = esc_html__( '.View Post Btn - Divi Machine', 'divi-machine' );
                    $this->slug = 'et_pb_de_mach_view_button';

                    $this->settings_modal_toggles = array(

      			'general' => array(
              'toggles' => array(
				      ),
      			),

      		);


                      $this->main_css_element = '%%order_class%%';
                      $this->fields_defaults = array();



                      $this->advanced_fields = array(
                  			'fonts' => array(
                  				'text' => array(
                  					'label'    => esc_html__( 'Button', 'divi-machine' ),
                  					'css'      => array(
                  						'main' => "%%order_class%% .et_pb_module_inner",
                  						'important' => 'plugin_only',
                  					),
                  					'font_size' => array(
                  						'default' => '14px',
                  					),
                  					'line_height' => array(
                  						'default' => '1em',
                  					),
                  				),
                  			),
                        'button' => array(
                        'button' => array(
                          'label' => esc_html__( 'Button', 'divi-machine' ),
                          'css' => array(
                            'main' => "{$this->main_css_element} .et_pb_button",
                            'important' => 'all',
                          ),
                          'box_shadow'  => array(
                            'css' => array(
                              'main' => "{$this->main_css_element} .et_pb_button",
                                  'important' => 'all',
                            ),
                          ),
                          'margin_padding' => array(
                          'css'           => array(
                            'main' => "{$this->main_css_element} .et_pb_button",
                            'important' => 'all',
                          ),
                          ),
                        ),
                    			),
                                          'background' => array(
                                                  'settings' => array(
                                                          'color' => 'alpha',
                                                  ),
                                          ),
                                          'border' => array(),
                                          'custom_margin_padding' => array(
                                                  'css' => array(
                                                          'important' => 'all',
                                                  ),
                                          ),
                                  );
                      $this->custom_css_fields = array();


          }

                  function get_fields() {
                      $fields = array(
			'title' => array(
				'label'           => esc_html__( 'Button Text', 'divi-machine' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
        'default'         => 'View Post',
        'toggle_slug'       => 'main_content',
				'description'     => esc_html__( 'Input your desired button text.', 'divi-machine' ),
			),
      'custom_url' => array(
        'label'       => __( 'Custom URL End', 'divi-machine' ),
        'type'        => 'text',
        'toggle_slug'       => 'main_content',
				'option_category' => 'basic_option',
        'description' => __( 'If you want to add an extension after the URL such as an anchor link - add it here. For example add #buynow to go to a section on the product page that has the ID "buynow".', 'et_builder' ),
                  ),
        'fullwidth_btn' => array(
                  'toggle_slug'       => 'main_content',
                    'label' => esc_html__( 'Fullwidth Button?', 'divi-machine' ),
                    'type' => 'yes_no_button',
            				'option_category' => 'basic_option',
                    'options' => array(
                      'on' => esc_html__( 'Yes', 'divi-machine' ),
                      'off' => esc_html__( 'No', 'divi-machine' ),
                    ),
                    'default' => 'on',
                    'description' => esc_html__( 'If you want to make your button fullwdith of the available space, enable this.', 'divi-machine' )
                  ),
                      );

                      return $fields;
                  }

                  function render( $attrs, $content = null, $render_slug ) {

                  self::$button_text      	= $this->props['title'];

                  $custom_url  = $this->props['custom_url'];
                  $title  = $this->props['title'];
                  $button_use_icon          	= $this->props['button_use_icon'];
                  $custom_icon          		= $this->props['button_icon'];
                  $button_custom        		= $this->props['custom_button'];
                  $button_bg_color       		= $this->props['button_bg_color'];
                  $fullwidth_btn       		= $this->props['fullwidth_btn'];

                  $data = '';


                  if ($fullwidth_btn == 'on') {
                      $this->add_classname('fullwidth-btn');
                  }

                  //////////////////////////////////////////////////////////////////////


                  ob_start();
                  $post_link = get_permalink(get_the_ID());
                  ?>
                <a class="et_pb_button" href="<?php echo $post_link ?><?php echo $custom_url ?>"><?php echo $title; ?> </a>

                  <?php

        if( $button_use_icon == 'on' && $custom_icon != '' ){
  			$custom_icon = 'data-icon="'. esc_attr( et_pb_process_font_icon( $custom_icon ) ) .'"';
  			ET_Builder_Element::set_style( $render_slug, array(
  				'selector'    => 'body #page-container %%order_class%% .et_pb_button:after',
  				'declaration' => "content: attr(data-icon);",
  			) );
  		}else{
  			ET_Builder_Element::set_style( $render_slug, array(
  				'selector'    => 'body #page-container %%order_class%% .et_pb_button:hover',
  				'declaration' => "padding: .3em 1em;",
  			) );
  		}

  		if( !empty( $button_bg_color ) ){

  			ET_Builder_Element::set_style( $render_slug, array(
  				'selector'    => 'body #page-container %%order_class%% .et_pb_button',
  				'declaration' => "background-color:". esc_attr( $button_bg_color ) ."!important;",
  			) );
  		}

                  $data = ob_get_clean();
                  //////////////////////////////////////////////////////////////////////

                  $data = str_replace(
              			'class="et_pb_button"',
              			'class="et_pb_button"' . $custom_icon
              			, $data
              		);

                  return $data;

                  }
              }

            new de_mach_view_button_code;

?>
